/*
 * @(#) Jessic.java 99/1/28
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.GUI;
 
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.URL;

import com.sun.java.swing.*;

/**
 * This applet graphics interface on web of CLUSTERPROBE.
 * 
 * @author Jimmy Liang
 * @version 1.00 11/23/98
 */

public class JessicApplet extends JApplet {

	public void init() {

		//Force Jessic to come up in the Cross Platform L&F
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
			// If you want the system L&F instead, comment out the above line and uncomment the following:
			//UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		}catch(Exception e){
			System.out.println("Error loading L&F: "+e);
		}
System.out.println("herer1");		
		//Check java version
		try {
		String vers = System.getProperty("java.version");
		if (vers.compareTo("1.1.2") <0) {
			System.out.println("!!!WARNING: Swing must be run with a "+"1.1.2 or higher version VM!!!");
		}

		setCursor(new Cursor(Cursor.WAIT_CURSOR));

		URL url = getDocumentBase();
		String propertyLocation = "http://"+url.getHost()+"/Jessic.properties";
		url = new URL(propertyLocation);
		BundleGroup.setProperty(url);
		showStatus(BundleGroup.property.getString("Title"));
		getContentPane().add("Center",new Jessic());

		}catch(Throwable t) {
			System.out.println("uncaught exception: "+t);
			t.printStackTrace();
		}
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}

}
