import java.net.*;
import java.io.*;

public class socketServer extends Thread
{
int port = 7004;
ServerSocket listen_socket;

public static void main(String[] args) {
	new socketServer();
}

public socketServer()
{
	try {
	listen_socket = new ServerSocket(port);
	}catch(IOException e) 
	{
		System.out.println(e);
		System.exit(-1);
	}
	System.out.println("Server:listening on port "+port);
	this.start();
}

public void run()
{
	boolean DebugFlag = true;
	if (DebugFlag) System.out.println("In socketServer Thread.");
	try {
	while (true)
	{
		Socket client_socket = listen_socket.accept();
		DataInputStream in = new DataInputStream(client_socket.getInputStream());
		DataOutputStream out = new DataOutputStream(client_socket.getOutputStream());

		short type = in.readShort();
		short id = in.readShort();
		System.out.println("type="+type+", id="+id);

		String sss = "0123456789";
		//System.out.println(bbb.length);
		out.writeShort(111);


		out.writeLong(111);
		//out.writeBytes(sss);

		out.close();
		in.close();
		client_socket.close();
	}
	}catch(Exception e){
		System.out.println(e);
		System.exit(-2);
	}
	if(DebugFlag) System.out.println("End of socketServer Thread.");
 }
	
}


