/*
 * @(#) ManipulateDemo.java 99/23/3
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.demo;
 
import java.net.URL;
import java.util.*;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.manipulate.*;
import CLUSTERPROBE.security.Password;

/**
 * Demonstrate how to manipulate the cluster.
 * 
 * @author Jimmy Liang
 * @version 1.00 3/23/99
 */

public class ManipulateDemo extends Object
{

	static int ss = 0;
	public ManipulateDemo(String server, int port)
	{
		super();
		try {
		if (EventTransceiver.current==null)
		{
			new EventTransceiver(server,port);	
		}

/*
		Manipulation mp = new Manipulation() {

			public void operate(Hashtable args, Password pw)
			{
			 ss++;
			 if ((ss/2)==0)
                         	System.out.println("Doing first thing...");
			 else
				System.out.println("Doing another thing..."); 
			};

                        public boolean isAlive() {
                                return false;
                        }

                        public Object getResult()
                        {
				if ((ss/2)==0)
                                return "haha....";
				else
				return "haha1....";
                        }

                        public long getTimeout() {
                                return 4000;
                        }

                        public boolean isSuccess() {
                                return true;
                        }
                };          

		Hashtable ht = new Hashtable();
		ht.put("c414b1.csis.hku.hk",mp);
		ht.put("wchip.csis.hku.hk",mp);
		ManipulateEvent man = new ManipulateEvent("Test",ht);
		Vector v = new Vector();
		v.addElement("c414b1.csis.hku.hk");
		man.addOrder(0,v);
		Vector v1 = new Vector();
		v1.addElement("c414b1");
		man.addOrder(1,v1);
*/
		
		Hashtable ht = ManipulateFile.getPreset("/etc/presets");
		ManipulateEvent man = (ManipulateEvent) ht.get("Compile");
		Password pw = new Password("/tmp","zyliang","33j82i334m");
		man.setPasswd(pw);

		EventHandler handler = new EventHandler() {
			Hashtable ht = new Hashtable();

			public void handleEvent(JessicEvent e)
			{
				int id = e.getId();
				if (id==JessicEvent.MANIPULATERESULT)
				{
					ManipulateResultEvent evt = (ManipulateResultEvent) e;
					String source = evt.getOperateSource();
					if (!ht.containsKey(source))
					{
						if (evt.isEnd())
							System.out.print("\n"+evt.getOperateSource()+":\n"+evt.getResult());
						else
						{
							Vector vt = new Vector();
							ht.put(source,vt);
							vt.addElement(evt.getResult());
						}
					}
					else
					{
						Vector vt = (Vector) ht.get(source);
						vt.addElement(evt.getResult());
						if (evt.isEnd())	
						{
							for (int kk=0;kk<vt.size();kk++)
							{
								if (kk==0)
									System.out.print("\n"+evt.getOperateSource()+":\n"+vt.elementAt(kk));
								else
									System.out.print(vt.elementAt(kk));
							}
		
						}
					}
				} 
				else if (id==JessicEvent.ERROR)
				{
					ErrorEvent err = (ErrorEvent) e;
					System.out.println(err.getErrMessage());
				}
				System.out.println("");
			}
		};
		EventTransceiver.current.addHandler(handler,new ManipulateResultEvent());
		EventTransceiver.current.addHandler(handler,new ManipulateErrorEvent());
		EventTransceiver.current.sendEvent(man);
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7003;

		ManipulateDemo demo = new ManipulateDemo(server,port);
	}
			
}
