/*
 * @(#) JessicEvent.java 99/1/09
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.EventObject;

/**
 * The jessica root event type. 
 *
 * @author Jimmy Liang
 * @version 1.00 2/9/99
 */

public class JessicEvent extends EventObject
{
	public final static int ROOT = 0;
	public final static int REFRESH = 1;
	public final static int REGISTRY = 2;
	public final static int ERROR = 3;
	public final static int MONITORREGISTRY = 4;
	public final static int REGISTERINFO = 5;
	public final static int MONITORDATA = 6;
	public final static int MANIPULATEREGISTRY = 7;
	public final static int MANIPULATERESULT = 8;
	public final static int PASSWORD = 9;

	int ID = ROOT;
 
	public JessicEvent() {
		super("");
	}

	public JessicEvent(String rn) {
		super("");
	}

	public void setId(int id)
	{
		ID = id;
	}

	public int getId()
	{
		return ID;
	}

}
