/*
 * @(#) PasswdEvent.java 99/4/16
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Calendar;
import CLUSTERPROBE.security.*;

/**
 * The event type defined by this class stands for password information
 *
 * @author Jimmy Liang
 * @version 1.00 4/16/99
 */

public class PasswdEvent extends JessicEvent
{
	Password pw = null;

	public PasswdEvent(Password pw)
	{
		super();
		setId(JessicEvent.PASSWORD);
		this.pw = pw;
	}

	public void setPasswd(Password pw)
	{
		this.pw = pw;
	}

	public Password getPasswd()
	{
		return pw;
	}
}
