/*
 * @(#) RegisterInfoEvent.java 99/3/03
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Vector;

/**
 * The event type defined by this class prensents the registered information. 
 *
 * @author Jimmy Liang
 * @version 1.00 3/3/99
 */

public class RegisterInfoEvent extends JessicEvent
{
	public final static int RESOURCE = 0; 
	public final static int MONITOR = 1;

	int type = RESOURCE;
	Vector info = null;

	public RegisterInfoEvent() {
		super("");
		setId(JessicEvent.REGISTERINFO);
	}

	public RegisterInfoEvent(int type, Vector v) 
	{
		super("");
		setId(JessicEvent.REGISTERINFO);
		this.type = type;
		info = v;
	}

	public void setType(int in) {
		type = in;
	}

	public int getType() {
		return type;
	}

	public void setInfo(Vector v)
	{
		info = v;
	}

	public Vector getInfo()
	{
		return info;
	}
}
