/*
 * @(#) ResourceData.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.*;
import java.io.Serializable;

/**
 * Define the format of the resource data 
 *
 * @author Jimmy Liang
 * @version 1.00 12/21/98
 */

public class ResourceData extends Object implements Serializable
{
	String resourceName;
	int type;
	
	public static final int LEAFVALUE = 0;
	public static final int TABRECORD = 1;

	public ResourceData(String name, int type) {
		resourceName = name;
		this.type = type;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType()
	{
		return type;
	}

	public void setName(String name)
	{
		resourceName = name;
	}

	public String getName()
	{
		return resourceName;
	}

}
