/*
 * @(#) ResourceLeafData.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.*;

/**
 * Define the format of the leaf resource data 
 *
 * @author Jimmy Liang
 * @version 1.00 12/21/98
 */

public class ResourceLeafData extends ResourceData
{
	Object value = null;

	public ResourceLeafData(String rn) {
		super(rn,ResourceData.LEAFVALUE);
	}

	public ResourceLeafData(String rn, Object obj)
	{
		super(rn, ResourceData.LEAFVALUE);
		value = obj;
	}

	public void setValue(Object obj)
	{
		value = obj;
	}

	public Object getValue()
	{
		return value;
	}

}
		
		
