/*
 * @(#) Cluster_HAApp_conf 01/09/07
 * Author: Wang Lin
 */ 

//package JESSIC.resources;
package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.*;

/**
 * Define the resource format of Cluster-HAApp_conf
 */

//modified from Cluster_HANode_conf
public class Cluster_HAApp_conf 
{
	String filename = "";
	String HAAppname="";
	String Hostgroup="";
	String Prinode="";
	String Secnode="";
	String MonTime="";
	String MonFilename="";
	String WorkDayF="";
	String WorkDayT="";
	String WorkHourF="";
	String WorkHourT="";
	String AlertScript="";
	String AlertMail="";
	String AlertTime="";
	String AppKey="";
	String HAIP="";
	String RunCommand="";
	String Nodepair="";
	
	public Cluster_HAApp_conf()
	{
		initData();
	}
	public void initData()
	{
		filename = "";
		HAAppname="";
		Nodepair="";
		Hostgroup="";
		Prinode="";
		Secnode="";
		MonTime="";
		MonFilename="";
		WorkDayF="";
		WorkDayT="";
		WorkHourF="";
		WorkHourT="";
		AlertScript="";
		AlertMail="";
		AlertTime="";
		AppKey="";
		HAIP="";
		RunCommand="";
	}
	public void setFilename(String ref)
	{
		filename=ref;
		return;
	}	

	public void setHAAppname(String ref)
	{
		HAAppname=ref;
		return;
	}

	public void setHostgroup(String ref)
	{
		Hostgroup=ref;
		return;	
	}

	public void setPrinode(String ref)
	{
		Prinode=ref;
		return;
	}

	public void setSecnode(String ref)
	{
		Secnode=ref;
		return;	
	}

	public void setMonTime(String ref)
	{
		MonTime=ref+"s";
		return;
	}
	
	public void setMonFilename(String ref)
	{
		MonFilename=ref;
		return;
	}

	public void setWorkDayF(String ref)
	{
		WorkDayF=ref;
		return;
	}

	public void setWorkDayT(String ref)
	{
		WorkDayT=ref;
		return;
	}

	public void setWorkHourF(String ref)
	{
		WorkHourF=ref;
		return;
	}

	public void setWorkHourT(String ref)
	{
		WorkHourT=ref;
		return;
	}

	public void setAlertScript(String ref)
	{
		AlertScript=ref;
		return;
	}

	public void setAlertMail(String ref)
	{
		AlertMail=ref;
		return;
	}
	
	public void setAlertTime(String ref)
	{
		AlertTime=ref+"m";
		return;
	}
	
	public void setAppKey(String ref)	{
		AppKey=ref;
		return;
	}
	public void setHAIP(String ref)
	{
		HAIP=ref;
		return;
	}
	public void setNodepair(String ref)
	{
		Nodepair=ref;
		return;
	}
	public void setRunCommand(String ref)
	{
		RunCommand=ref;
		return;
	}
	
	public String getRunCommand()
	{
		return RunCommand;
	}	

	public String getNodepair()
	{
		return Nodepair;
	}	

	
	public String getFilename()
	{
		return filename;
	}	

	public String getHAAppname()
	{
		return HAAppname;
	}

	public String getHostgroup()
	{
		return Hostgroup;	
	}

	public String getPrinode()
	{
		return Prinode;
	}

	public String getSecnode()
	{
		return Secnode;	
	}

	public String getMonTime()
	{
		return MonTime;
	}
	
	public String getMonFilename()
	{
		return MonFilename;
	}

	public String getWorkDayF()
	{
		return WorkDayF;
	}

	public String getWorkDayT()
	{
		return WorkDayT;
	}

	public String getWorkHourF()
	{
		return WorkHourF;
	}

	public String getWorkHourT()
	{
		return	WorkHourT;
	}

	public String getAlertScript()
	{
		return AlertScript;
	}

	public String getAlertMail()
	{
		return AlertMail;
	}
	
	public String getAlertTime()
	{
		return AlertTime;
	}
	
	public String getAppKey()	
	{
		return AppKey;
	}
	public String getHAIP()
	{
		return HAIP;
	}
	public void cpfile(String fromfile,String tofile)
	{
		try{
				File inputFile = new File(fromfile);
				File outputFile = new File(tofile);

				FileReader in = new FileReader(inputFile);
				FileWriter out = new FileWriter(outputFile);
				int c;

				while ((c = in.read()) != -1)
					out.write(c);

				in.close();
				out.close();
    		}catch(IOException e){
			System.out.println("Exception:"+e);
			}
	}
	public void writeToFile(String filename,String flag)
	{
		boolean debugflag=false;
		String dfilename="";
		String dir="/etc/HAscript/tmp/";
				
		if(flag.equals("p"))
			dfilename="pri."+filename;
		else if (flag.equals("s"))
			dfilename="sec."+filename;
		else 
		{
			System.out.println("Wrong flag!");
			return;
		}

		if(filename.equals("mon.cf"))
	    {
			String dfile=dir+dfilename;
			String tfile="";
			if(flag.equals("p"))
				tfile=dir+filename+".tmp1";
			else
				tfile=dir+filename+".tmp2";

		//---for file mon.cf
		try{
			if(debugflag) System.out.println("begin to write file mon.cf");
			RandomAccessFile in=new RandomAccessFile(tfile,"r");
			FileWriter out=new FileWriter(dfile);				
			
			String line="";
			boolean flag2=true;  // after hostgroup line, the # line would be deleted.
			boolean flag1=true;
			line=in.readLine();
			while(line!=null)
			{
				//System.out.println("Line:"+line);
				StringTokenizer st1=new StringTokenizer(line," ");
				if(line.startsWith("#"))
				{	
					if(debugflag) System.out.println(line);
					if(debugflag) System.out.println("line begin with #");
					if (flag2)
					{
						for(int i=0;i<line.length();i++)
							out.write(line.charAt(i));
						out.write("\n");
					}
					line=in.readLine();
					continue;
				}
				String word=null;
				if(st1.hasMoreTokens())
				{
					word=st1.nextToken();
					//System.out.println("word:"+word);
					if((!word.equals("hostgroup"))&&(!word.equals("watch")))
					{
						//System.out.println(word+" != "+getHAnpname());
						for(int i=0;i<line.length();i++)
							out.write(line.charAt(i));
						out.write('\n');
						if (debugflag) System.out.println(line);
						line=in.readLine();
					}
					else if(word.equals("hostgroup"))
					{
						flag2=false;
						if(flag1)
						{
							out.write("hostgroup "+getHostgroup()+" "+getPrinode()+"\n\n");			
							if (debugflag) System.out.print("hostgroup "+getHostgroup()+" "+getPrinode()+"\n");
							flag1=false;
						}
						word=st1.nextToken();
						if(!word.equals(getHostgroup()))
						{
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							out.write('\n');
							if (debugflag) System.out.println(line);
						}
						line=in.readLine();
					}
					else if(word.equals("watch"))
					{
						if(flag1)
						{
							if(debugflag) System.out.println("flag1=true");
							out.write("hostgroup "+getHostgroup()+" "+getPrinode()+"\n\n");
							if (debugflag) System.out.print("hostgroup "+getHostgroup()+" "+getPrinode()+"\n");
							flag1=false;
						}
						word=st1.nextToken();
						if(!word.equals(getHostgroup()))
						{
							out.write("#\n#  "+word+"\n#\n");
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							out.write('\n');
							if (debugflag) System.out.println(line);
							
							while((line=in.readLine())!=null)
							{
								StringTokenizer st=new StringTokenizer(line," ");
								String word1=null;
								if(st.hasMoreTokens())
								{
									word1=st.nextToken();
									if(!word1.equals("watch"))
									{
										for(int i=0;i<line.length();i++)
											out.write(line.charAt(i));
										out.write('\n');
										if (debugflag) System.out.println(line);
									}
									else break;
								}
							}
						}
						else
						{
							line=in.readLine();
							while(line!=null)
							{
								StringTokenizer st=new StringTokenizer(line," ");
								String word1=null;
								if(st.hasMoreTokens())
								{
									word1=st.nextToken();
									if(word1.equals("watch"))
										 break;
									else line=in.readLine();
								}
								else line=in.readLine();
							}

						}
					}
				}
				else line=in.readLine();
			}
			if(flag1)
			{
				if(debugflag) System.out.println("flag1=true");
				out.write("hostgroup "+getHostgroup()+" "+getPrinode()+"\n\n");
				flag2=false;
				if (debugflag) System.out.print("hostgroup "+getHostgroup()+" "+getPrinode()+"\n");
				flag1=false;
			}

			out.write("#\n");
			out.write("#  "+getHostgroup()+"\n");
			out.write("#\n");
			out.write("watch "+getHostgroup()+"\n");
			out.write("	service "+getHAAppname()+"\n");
			out.write("		interval "+getMonTime()+"\n");
			out.write("		monitor "+getMonFilename()+"\n");
			out.write("		period wd {"+getWorkDayF()+"-"+getWorkDayT()+"}  hr {"+getWorkHourF()+"-"+getWorkHourT()+"}\n");
			out.write("			alert "+getAlertScript()+"\n");
			out.write("			alert mail.alert "+getAlertMail()+"\n");
			out.write("			alert page.alert "+getAlertMail()+"\n");
			out.write("			alertevery "+getAlertTime()+"\n");
			if (debugflag) System.out.print("watch "+getHostgroup()+"\n");
			if (debugflag) System.out.print("	service "+getHAAppname()+"\n");
			if (debugflag) System.out.print("	interval "+getMonTime()+"\n");
			if (debugflag) System.out.print("	monitor "+getMonFilename()+"\n");
			if (debugflag) System.out.print("	period wd {"+getWorkDayF()+"-"+getWorkDayT()+"}  hr {"+getWorkHourF()+"-"+getWorkHourT()+"}\n");
			if (debugflag) System.out.print("		alert "+getAlertScript()+"\n");
			if (debugflag) System.out.print("		alert mail.alert "+getAlertMail()+"\n");
			if (debugflag) System.out.print("		alertevery "+getAlertTime()+"\n");
			line=in.readLine();
			
			in.close();
			out.close();
			if(debugflag) System.out.println("end of write mon.cf");
    	}catch(IOException e){
			System.out.println("Exception:"+e);
		}
		}
		else if(filename.equals("app.monitor")) 
		{
			//--- for file app.monitor
			if(flag.equals("p"))
				filename="pri."+getHAAppname()+".monitor";
			else
				filename="sec."+getHAAppname()+".monitor";
			String dfile=dir+filename;
			
			try{
				 File outputFile = new File(dfile);
       			 FileWriter out = new FileWriter(outputFile);
				
				 out.write("#!/bin/sh"+"\n");
				 out.write("p=`ps auxw | grep "+getAppKey()+"`\n");
				 out.write("result=\"\"\n");
				 out.write("if $p >/dev/null 2>/dev/null\n");
				 out.write("then\n");
				 out.write("echo \"no\"\n");
				 out.write("result=\"no\"\n");
				 out.write("else\n");
				 out.write("echo \"yes\"\n");
				 out.write("result=\"yes\"\n");
				 out.write("fi\n");
				 out.write("if [ \"$result\" != \"yes\" ]\n");
				 out.write("then\n");
				 out.write("exit 1\n");
				 out.write("fi\n");
				 out.write("exit 0\n");
				out.close();
				if(debugflag) System.out.println("end of write app.monitor");
			}catch(IOException e){
				System.out.println("Exception:"+e);
			}
		}	
		else if(filename.equals("alert.script"))
		{
			//--- for file alert.script
			if(flag.equals("p"))
				filename="pri."+getAlertScript();
			else
				filename="sec."+getAlertScript();
			
			String dfile=dir+filename;
			try{
				 File outputFile = new File(dfile);
       			 FileWriter out = new FileWriter(outputFile);
				
				 out.write("#!/bin/sh"+"\n");
				 StringTokenizer st1=new StringTokenizer(getRunCommand(),";");
				 
				 if(st1.hasMoreTokens())
				 {
					 do{
						String word = st1.nextToken();
						out.write(word+"\n");
					 }while (st1.hasMoreTokens());	 
				 }
				 else
					out.write(getRunCommand()+"\n");
				 out.close();
			}catch(IOException e){
				System.out.println("Exception:"+e);
			}
			
			//--- for run script
			if(flag.equals("p"))
				filename="pri."+getHAAppname();
			else
				filename="sec."+getHAAppname();
			dfile=dir+filename;
			
			try{
				 File outputFile = new File(dfile);
       			 FileWriter out = new FileWriter(outputFile);
				
				 out.write("#!/bin/sh"+"\n");
				 StringTokenizer st1=new StringTokenizer(getRunCommand(),";");
				 
				 if(st1.hasMoreTokens())
				 {
					 do{
						String word = st1.nextToken();
						out.write(word+"\n");
					 }while (st1.hasMoreTokens());	 
				 }
				 else
					out.write(getRunCommand()+"\n");
				 out.close();
			}catch(IOException e){
				System.out.println("Exception:"+e);
			}
			if(debugflag) System.out.println("end of write alert.script and run.script");
		}
		else if(filename.equals("haresources"))
		{
			//---for file haresources
			String dfile=dir+dfilename;
			String tfile="";
			boolean haflag=true;
			if(flag.equals("p"))
				tfile=dir+filename+".tmp1";
			else
				tfile=dir+filename+".tmp2";

			try{
				RandomAccessFile in=new RandomAccessFile(tfile,"r");
				FileWriter out=new FileWriter(dfile);				
			
				String line="";
				while((line=in.readLine())!=null)
				{
					//System.out.println("Line:"+line);
					StringTokenizer st1=new StringTokenizer(line," ");
					String word=null;
					if(st1.hasMoreTokens())
					{
						word=st1.nextToken();
						//System.out.println("---!word:"+word);
						//System.out.println("---!getPrinode="+getPrinode());
						if(!word.equals(getPrinode()))
						{
							//System.out.println(word+" != "+getHAnpname());
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							System.out.println(line);
							out.write('\n');
						}
						else 
						{
							word=st1.nextToken();
							while(st1.hasMoreTokens())
							{
								word=st1.nextToken();
								if(word.equals(getHAAppname()))
									haflag=false;
								//word=st1.nextToken();
							}
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							out.write('\n');
						}
					}
				}
			if(haflag) out.write(getPrinode()+" "+getHAIP()+" "+getHAAppname()+"\n");
			in.close();
			out.close();
	 	}catch(IOException e){
			System.out.println("Exception:"+e);
		}
		if(debugflag) System.out.println("end of write haresources");
		}
		return;
	}
}


