/*
 * @(#) Cluster_Workstation_Network_ContTable_Udp.java 99/4/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 * Define the format of Cluste_Workstation Udp connection table
 *
 * @author Jimmy Liang
 * @version 1.00 4/9/99
 */

public class Cluster_Workstation_Network_ContTable_Udp extends Cluster_Workstation_Network_ContTable
{
	public Cluster_Workstation_Network_ContTable_Udp()
	{
		super();
		cmd =  "/bin/netstat --udp";
	}

	public static void main(String[] args) {
		Cluster_Workstation_Network_ContTable_Udp rs = new Cluster_Workstation_Network_ContTable_Udp();
		Hashtable ht = null;
		try{
		ht = rs.getHashtable();
		}catch(Exception ee){
			System.out.println(ee);
			System.exit(-1);
		}
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("---------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "UDP Connection Table";
	}

}
