package CLUSTERPROBE.rmi;

import java.io.*;
import java.util.*;

public class RunCmd{

	protected String ErrMsg;
	protected String Result;
	protected DataInputStream CrtStream;
	protected Process df_proc;

	/** The method can execute command and return full error message*/
public synchronized boolean runcmd(String command){
    boolean isCorrect = false;
    System.out.println(command);
    try{
      df_proc = Runtime.getRuntime().exec(command);
      //df_proc.exitValue();
	  df_proc.waitFor();
	}catch(IOException e){
		System.out.println("IOException occured"); 
		return false;
	}catch(InterruptedException e){
		System.out.println("InterruptedException occured"); 
		return false;
	}
	
	if(df_proc.exitValue()==0)
          isCorrect = true;
    else
        isCorrect = false;
    return isCorrect;
  }

	public String getResult() {
		try{
			InputStream crt=df_proc.getInputStream();
 			int lenc=crt.available();
			if (lenc<1) {
				System.out.println("lenc <1"); 
				return "";
			}
			else {
				CrtStream=new DataInputStream(crt);
				byte[] b=new byte[lenc];
				try {
					CrtStream.readFully(b);
				} catch (EOFException x) {
				}
				CrtStream.close();
				Result=new String(b); 
			}
		} catch (Exception e){
			return e.toString();
		}
		return Result;
	}

}

