
/* %Z% %M%, Release %R%.%L%, %E%,%U% */ 

import java.io.*;
import java.util.*;

public class RunCmd{

	protected String ErrMsg;
	protected String Result;
	protected DataInputStream CrtStream;
	protected Process df_proc;
	//DestroyProc p2; 

	/** The method can execute command and return full error message*/

	public synchronized boolean runcmd(String command,int timeout) {
	
		boolean isCorrect = false;
		File f;

		StringTokenizer st = new StringTokenizer(command);
		int i=0;
		//String[] cmd = new String[st.countTokens()];
		Vector cmdString = new Vector();
		boolean add = false;
		while (st.hasMoreTokens()) {
			String temp = st.nextToken();
System.out.println(temp);
			if (!add) {
				if (temp.startsWith("'")) {
					if (temp.equals("'")) {
						cmdString.addElement("");
						add = true;
					}
					else {
						if (temp.endsWith("'"))
							cmdString.addElement(temp.substring(1,temp.length()-1));
						else {
							cmdString.addElement(temp.substring(1));
							add = true;
						}
					}
				}
				else
					cmdString.addElement(temp);
			}
			else {
				int k = cmdString.size()-1;
				if (temp.endsWith("'")) {
					add = false;
					temp = temp.substring(0, temp.length()-1);
				}
				cmdString.setElementAt(cmdString.elementAt(k)+" "+temp, k);
			}
		}
		String[] cmd = new String[cmdString.size()];
		for (i=0; i<cmdString.size(); i++) {
			cmd[i] = cmdString.elementAt(i).toString();
			System.out.println(cmd[i]);
		}
		/*
		int t = command.indexOf(" ");
		if (t > 0)
			f = new File(command.substring(0,t));
		else
			f = new File(command);
		*/
		f = new File(cmd[0]);
		try {
			if (!f.exists()) {
				ErrMsg = "Command "+command+" does not exist.";
				//FailInformation.setError(ErrMsg);
				return false;
			}
		} catch (SecurityException x) {
			ErrMsg = x.toString();
			//FailInformation.setError(ErrMsg);
			return false;
		};

		try{
			System.out.println(timeout);
		System.out.println(command+" "+timeout);
			//df_proc = Runtime.getRuntime().exec(command);
			df_proc = Runtime.getRuntime().exec(cmd);
			if (timeout == -1)
				return true;
			for( i=0;i<(timeout/100);i++) 
			{
				try {
					df_proc.exitValue();
					break;
				} catch (IllegalThreadStateException x) {};
				try {
					Thread.sleep(100);
				} catch(InterruptedException e) {
					//FailInformation.setError(e.toString());
					return false;
				}
			}
			if (i==(timeout/100)) { 
				ErrMsg = "The process was destroyed for timeout.";
				df_proc.destroy();
			}
			else
				if (df_proc.exitValue()==0)
					isCorrect = true;
		} catch (Exception e){
			ErrMsg = e.toString();
			isCorrect = false;
		}								
		if (!isCorrect) {
			if (ErrMsg == null)
				ErrMsg = getErrMsg();
			//FailInformation.setError(ErrMsg);
		}
		return isCorrect;
	}
     
public synchronized boolean runcmd(String command){
    boolean isCorrect = false;
    File f;
    int t = command.indexOf(" ");
    System.out.println(command);
    if (t > 0)
      f = new File(command.substring(0,t));
    else
      f = new File(command);
    try {
      if (!f.exists()) {
        ErrMsg = "Command "+command+" does not exist.";
        //FailInformation.setError(ErrMsg);
        return false;
      }
    } catch (SecurityException x) {
      ErrMsg = x.toString();
      //FailInformation.setError(ErrMsg);
      return false;
    }

    try{
      df_proc = Runtime.getRuntime().exec(command);
//      while(true){
      int i=0;
      for(i=0;i<7200;i++) {
          try{
        df_proc.exitValue();
        break;
        }catch (IllegalThreadStateException x) {};
        try {
        Thread.sleep(1000);
        }catch(InterruptedException e) {//FailInformation.setError(e.toString());
				return false;}
      }
      if (i>=7200){
          isCorrect = false;
//          FailInformation.setError("Process was destroyed for timeout");
          df_proc.destroy();
      }
      else if (df_proc.exitValue()==0)
          isCorrect = true;
    }catch(Exception e){
        ErrMsg = e.toString();
        isCorrect = false;
    }
    if (!isCorrect) {
      if (ErrMsg == null)
        ErrMsg = getErrMsg();
        //FailInformation.setError(ErrMsg);
    }
    return isCorrect;
  }

/** get exitValue of df_proc, must be called after runcmd() */
	public int getExitValue(){
			int retv;
		  try{
        retv = df_proc.exitValue();
			return retv;
      }catch (IllegalThreadStateException x) {//{return GetError.GETFAIL;};
			return 200;}
	}

	public String getErrMsg() {
		if (ErrMsg != null)
			return ErrMsg;
		String errMsg;
		try{
     	InputStream err=df_proc.getErrorStream();
     	int lene=err.available();
			if (lene < 1) 
				return ("");
      DataInputStream errmsg=new DataInputStream(err);
      byte[] b=new byte[lene];
			try {
      	errmsg.readFully(b);
			} catch (EOFException x) {
			}
      errMsg="exitValue is :"+df_proc.exitValue()+"\n"+"error :\n"+new String(b);
      errmsg.close();
		} catch (IOException e){
			errMsg = e.toString();
		}
		return errMsg;
	}

	public String getResult() {
		try{
			InputStream crt=df_proc.getInputStream();
 			int lenc=crt.available();
			if (lenc<1) 
				return "";
			else {
				CrtStream=new DataInputStream(crt);
				byte[] b=new byte[lenc];
				try {
					CrtStream.readFully(b);
				} catch (EOFException x) {
				}
				CrtStream.close();
				Result=new String(b); 
			}
		} catch (Exception e){
			return e.toString();
		}
		return Result;
	}

	public DataInputStream getCrtStream() {
		if (df_proc==null) return null;
		InputStream crt=df_proc.getInputStream();
		CrtStream=new DataInputStream(crt);
		return CrtStream;
	}

	public static void main(String[] args) {
		RunCmd p2=new RunCmd();
		if (!p2.runcmd("/usr/sbin/wall ' '",5000)) {
//			System.out.println("error msg is : "+FailInformation.err_info+"\n");
		}
		else {
		    	System.out.println("string result: "+p2.getResult());
		}
		System.out.println("exit value is "+p2.getExitValue()+"\n\n");

		System.out.println("finish main");
	}
}

