include "clusterha.h";
/*
 * calling format : log(level,function_name,format,.....)
 *
 */
void log(int level,char * fmt,...)
{
    time_t      now;
    FILE        *fp;
    char        buf1[64],buf2[256],*t;
    char	pathfile[MAX_STRING_LEN];
    va_list args;
    struct stat statbuff;

    if (sharem->debuglevel >= level) {
      /* if( (fp = fopen(sharem->logfile, "a" )) == NULL ) {
        printf("log:file open error %s \n",sharem->logfile);
  	return;
      }*/
      switch(level) {
	case LOG_DEBUG: 
		sprintf(pathfile,"/var/HA/log/debug.log");
		stat(pathfile,&statbuff);
		if(statbuff.st_size> sharem->logsize) {
			system("cp /var/HA/log/debug.log /var/HA/log/debug.bak 2>/dev/null");
			system("rm /var/HA/log/debug.log 2>/dev/null");
		}
		break;
	case LOG_ERROR: 
		sprintf(pathfile,"/var/HA/log/err.log");
		stat(pathfile,&statbuff);
		if(statbuff.st_size> sharem->logsize) {
			system("cp /var/HA/log/err.log /var/HA/log/err.bak");
			system("rm /var/HA/log/err.log");
		}
		break;
	case LOG_WARNING: 
		sprintf(pathfile,"/var/HA/log/warning.log");
		stat(pathfile,&statbuff);
		if(statbuff.st_size> sharem->logsize) {
			system("cp /var/HA/log/warning.log /var/HA/log/warning.bak");
			system("rm /var/HA/log/warning.log");
		}
		break;
	default:return;
      }
      if( (fp = fopen(pathfile, "a" )) == NULL ) {
        printf("log:file open error %s \n",pathfile);
        return;
      }

      va_start(args,fmt);

      now = time(0);
      t = ctime(&now) + 4;
      t[strlen(t)-1] = '\0';
      sprintf(buf1,"%d : %s  %s:",level,t,fmt);
      fmt = va_arg(args, char *);
      vsprintf(buf2,fmt, args);
      fprintf(fp,"%s%s",buf1,buf2);
      va_end(args);
      fclose(fp);
    }
}
