/*
 * @(#)Password.java 99/4/16
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.security;
 
/**
 * Define the password structure.
 *
 * @author Jimmy Liang
 * @version 1.00 4/16/99
 */

public class Password extends Object implements java.io.Serializable
{
	String cwd = null;
	String passwd = null;
	String uname = null;

	public Password() {};

	public Password(String cwd, String uname, String passwd)
	{
		this.cwd = cwd;
		this.passwd = passwd;
		this.uname = uname;
	}

	public Password(String uname, String passwd)
	{
		this.passwd = passwd;
		this.uname = uname;
	}

	public String getPasswd()
	{
		return passwd;
	}

	public String getCWD()
	{
		return cwd;
	}

	public String getUname() 
	{
		return uname;
	}

	public void setPasswd(String pw)
	{
		passwd = pw;
	}
	
	public void setCWD(String c)
	{
		cwd = c;
	}

	public void setUname(String u)
	{
		uname = u;
	}

 }
