import java.rmi.server.RMIClassLoader;
import java.net.URL;
import java.rmi.registry.LocateRegistry;

public class LoadAgent2
{
	public static void main(String[] args)
	{
		System.setSecurityManager(new MySecurityManager());
		try{
			//Class cl = RMIClassLoader.loadClass(new URL("http://c414b1.csis.hku.hk/classes/"),"CLUSTERPROBE.rmi.StartThread");

			if (args==null||args.length==0)
				System.out.println("Please indicate where to download the agent codes!");

			//LocateRegistry.createRegistry(3000);
			Class cl = RMIClassLoader.loadClass(new URL(args[0]),"CLUSTERPROBE.rmi.StartThread");
			Runnable agent = (Runnable) cl.newInstance();
			agent.run();
		}catch(Exception ee)
		{
			System.out.println("Exception:"+ee.toString());
			ee.printStackTrace();
		}
	}
}

