import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;
import CLUSTERPROBE.message.ResourceTableData;

// modified by Wanglin , 01/09/17
public class CICS_HAappStatus extends HttpServlet
{
	boolean debugflag=false;
	PrintWriter out ;
	int appnum=0;
	Vector appD= new Vector();
	Vector nodeinfo=new Vector();
	Enumeration statusEn=null;

	
// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	out= response.getWriter();
	String type = request.getParameter("type").trim();
	if(debugflag) System.out.println("type="+type);
	if(type.equals("show"))
	{
		String server = null;
		int port = 0;
		try{
			server = InetAddress.getLocalHost().getHostName();
			port = 7001;
		}catch(Exception ee){
			out.println("<html><head><title>Error Server</title></head>");
			out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
			out.println("</html>");
			out.close();
			return;
		}

		out.println("<BASE href=\"http://"+server+"/srg/html/\">");
 		out.println("<html><META http-equiv='refresh' content='20,URL=/'>");
		out.println("<head>");
		out.println("<title>HA Applications Status</title>");

		out.println("<script language=javascript>");
		initApp();
		out.println("</script>");

		//get status from info server
		GetCurrentValueDemo demo = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_HAapp_StatusTable",server,port);
		if(debugflag) System.out.println("after get current value of Cluster_HAapp_StatusTable");
	
		try{Thread.sleep(2000);}catch(Exception eee){};
		int kk= 0;
		for (kk=0;kk<10;kk++)
		{
			if (demo.over)
				break;
			try{Thread.sleep(2000);}catch(Exception exp){};
		}
		if (kk==10) {
			System.out.println("kk==10");
			out.println("</head>");
			out.println("<body>");
			out.println("<br><center><h2>"+server+" Not reachable!</h2></center>");
			out.println("</body>");
			out.println("</html>");
			out.close();
			return;
		}
		if (!demo.success)
		{
			System.out.println("demo is not successful.");
			out.println("</head>");
			out.println("<body>");
			out.println("<br><center><h2>Error:"+demo.errMessage+"</h2></center>");
			out.println("</body>");
			out.println("</html>");
			out.close();
			return;
		}
		Vector dv = null;
		try {
			dv = (Vector)demo.value.elementAt(0);
		}catch(Exception ed){};
		if (dv==null)
		{
			if(debugflag) System.out.println("dv=null");
			out.println("</head>");
			out.println("<body>");
			out.println("<br><center><h2>Error: can't retrieve status info!</h2></center>");
			out.println("</body>");
			out.println("</html>");
			out.close();
			return;
		}
	
		out.println("</head>");
		out.println("<body bgcolor=#ffffff>");
		out.println("<center>");
	
	//Enumeration statusEn = dv.elements();
		statusEn = dv.elements();
		out.println("<script language=javascript>");
		getS(statusEn);
		out.println("</script>");	
	
	//out.println("<script src=\"../code/show_status3.js\" language=javascript></script>");
		showS();
	
		out.println("<script language=javascript>");
		out.println("showStatus(self);");
		out.println("</script>");
		out.println("</center>");
		out.println("</body>");
		out.println("</html>");
		out.close();
		return;
	}
	else if(type.equals("mani"))
	{	
		String server = null;
		int port = 0;
		try{
			server = InetAddress.getLocalHost().getHostName();
			port = 7001;
		}catch(Exception ee){
			out.println("<html><head><title>Error Server</title></head>");
			out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
			out.println("</html>");
			out.close();
			return;
		}

		out.println("<BASE href=\"http://"+server+"/srg/html/\">");
 		out.println("<html>");
		out.println("<head>");
		out.println("<title>HA Applications Manipulate</title>");
		out.println("<p align=\"center\"><font color=\"#F46C4A\"><strong>Manipulate HA Applications</strong></font></p>");
		out.println("</head>");
		out.println("<body bgcolor=#ffffff>");
		out.println("<center>");
		//out.println("<p><APPLET codebase=\"/home/httpd/html\" CODE=\"Clock.class\" WIDTH=100 HEIGHT=100></APPLET></p> ");

		out.println("<script language=javascript>");
		initApp();
		out.println("</script>");
		showS1();
	
		out.println("</center>");
		out.println("</body>");
		out.println("</html>");
		out.close();
		return;
	}
	
}
public void showS1()
{
	if(debugflag) System.out.println("appnum="+appnum);
	for(int i=0;i<appnum;i++)
	{
		String Appname=(String)appD.elementAt(0+i*3);
		String Priname=(String)appD.elementAt(1+i*3);
		String Secname=(String)appD.elementAt(2+i*3);
		if(debugflag) System.out.println("Appname="+Appname+"; Priname="+Priname+"; Secname="+Secname);
		
		out.println("<script language=javascript>");
		out.println("function "+Appname+"(oper){");
		out.println("if(oper==\"restart\"){");
		out.println("}");
		out.println("else if(oper==\"start\"){");
		out.println("if ((parent.parent.hapriUsr==\"\")||(parent.parent.hapriUsr==null))");
		out.println("{	alert(\"Please login Primary Node first!\");");
		out.println("return;}");
		out.println("if ((parent.parent.hasecUsr==\"\")||(parent.parent.hasecUsr==null))");
		out.println("{	alert(\"Please login Secondary Node first!\");");
		out.println("return;}");
		out.println("location.href=\"http://\"+location.hostname+\":8090/servlet/cics_hanodeMani?lname=\"+parent.parent.loginName+\"&passwd=\"+parent.parent.Password+\"&server=\"+location.hostname+\"&type=haapps5&flag=0\"+\"&next=/haappconf.html&app="+Appname+"&prin="+Priname+"&plname=\"+parent.parent.hapriUsr+\"&ppwd=\"+parent.parent.hapriPwd+\"&secn="+Secname+"&slname=\"+parent.parent.hasecUsr+\"&spwd=\"+parent.parent.hasecPwd;");
		out.println("}");
		out.println("else if(oper==\"stop\"){");
		out.println("}");
		out.println("else if(oper==\"takeover\"){");
		out.println("}");
		out.println("}");
		out.println("function login1(name){");
		out.println("parent.parent.hapriNode=name;");
		out.println("location.href=\"http://\"+location.hostname+\"/login_in_page.htm#login1\";");
		out.println("}");
		out.println("function login2(name){");
		out.println("parent.parent.hasecNode=name;");
		out.println("location.href=\"http://\"+location.hostname+\"/login_in_page.htm#login2\";");
		out.println("}");
		out.println("</script>");

		out.println("<form name=\"app."+Appname+"\">");
		out.println("<div align=\"center\"><center><p><img src=\"../../images/day_nigh.gif\" width=\"414\" height=\"9\"  align=\"left\"></p>");
		out.println("</center></div><div align=\"center\"><center><p>&nbsp;</p>");
		out.println("</center></div><div align=\"left\"><p>Application Name:&nbsp;&nbsp; <input type=\"text\" name=\"Appname\" size=\"20\" value=\""+Appname+"\" style=\"background-color: rgb(255,255,255); color: rgb(0,255,0); border: medium none rgb(255,255,255)\"></p>");
		//out.print("</div><div align=\"left\"><p>Primary Node:&nbsp; <input type=\"text\" name=\"Prinode\" value=\""+Priname+"\" size=\"20\" style=\"background-color: rgb(255,255,255); color: rgb(0,255,0); border: medium none rgb(255,255,255)\"></p>");
		out.print("</div><div align=\"left\"><p>Primary Node:&nbsp; <input type=\"text\" name=\"Prinode\" value=\""+Priname+"\" size=\"20\" style=\"background-color: rgb(255,255,255); color: rgb(0,255,0); border: medium none rgb(255,255,255)\">");
		out.print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ");
		out.print("<input type=\"button\" value=\"login\" name=\"loginp\" onclick=\"login1(&quot;"+Priname+"&quot;)\"></p>");

		//out.print("</div><div align=\"left\"><p>Secondary Node: <input type=\"text\" name=\"Secnode\" size=\"20\" value=\""+Secname+"\" style=\"background-color: rgb(255,255,255); color: rgb(0,255,0); border: medium none rgb(255,255,255)\"></p>");
		out.print("</div><div align=\"left\"><p>Secondary Node: <input type=\"text\" name=\"Secnode\" size=\"20\" value=\""+Secname+"\" style=\"background-color: rgb(255,255,255); color: rgb(0,255,0); border: medium none rgb(255,255,255)\">");
		out.print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ");
		out.print("<input type=\"button\" value=\"login\" name=\"logins\" onclick=\"login2(&quot;"+Secname+"&quot;)\"></p>");
		out.println("</div><blockquote>");
        out.println("<div align=\"center\"><center><p>");
		//out.println("<input type=\"button\" value=\"  Restart  \" name=\"start\" onclick=\""+Appname+"(&quot;start&quot)\">&nbsp;");
		//out.println("<input type=\"button\" value=\"   Stop  \" name=\"stop\" onclick=\""+Appname+"(&quot;stop&quot)\">&nbsp;&nbsp; ");
		out.println("<input type=\"button\" value=\" Start on both nodes \" name=\"start\" onclick=\""+Appname+"(&quot;start&quot)\">&nbsp;&nbsp; ");
		out.println("<input type=\"button\" value=\"Takeover\" name=\"takeover\" onclick=\""+Appname+"(&quot;takeover&quot)\"></p>");
        out.println("</center></div>");
		out.println("</blockquote><p>&nbsp;</p></form>");
	}
}

public void getS(Enumeration statusEn)
{
	//out.println("<script language=javascript>");
	while (statusEn.hasMoreElements())
	{
		if(debugflag) System.out.println("statusEn is not empty");
		ResourceTableData data = (ResourceTableData) statusEn.nextElement();
		Vector vt = data.getRecord();
		String hostname = trimHost((String)vt.elementAt(0));
		String des=(String)vt.elementAt(2);
		String state=(String)vt.elementAt(1);
		if(debugflag) System.out.println("hostname:"+hostname);
		if(debugflag) System.out.println("describe:"+des);
		if(debugflag) System.out.println("state:"+state);
		// Deal with the status of applications and nodes to determind the status of HA applications
		if (hostname==null) continue;
		if (!des.equals("READY"))
		{
			if(des.equals("RMI not ready"))
			{
				out.println("node[\""+hostname+"\"]=0;");
			}else if(des.equals("NOTREADY"))
			{
				out.println("node[\""+hostname+"\"]=1;");
/*				if(debugflag) System.out.println("host "+hostname+" is HA Not Ready");
				String line="";
				StringTokenizer st1=new StringTokenizer(state,"&");
				String word="";
				while(st1.hasMoreTokens())
				{
					line="app[\"run."+hostname+".";				
					word=st1.nextToken();
					StringTokenizer st2=new StringTokenizer(word,"=");
					String name=st2.nextToken();
					String state1=word.substring(name.length()+1,word.length());
					line=line+name+"\"]="+state1+";";
					out.println(line);
				}
*/
			}
			else 
			{
				out.println("node[\""+hostname+"\"]=3;");
			}
		}
		if(des.equals("READY"))
		{
			out.println("node[\""+hostname+"\"]=2;");
			String line="";
//			line="app[\""+hostname+".";
			StringTokenizer st1=new StringTokenizer(state,"&");
			String word="";
			while(st1.hasMoreTokens())
			{
				line="app[\""+hostname+".";				
				word=st1.nextToken();
				if(debugflag) System.out.println("word:"+word);
				StringTokenizer st2=new StringTokenizer(word,"=");
				String name=st2.nextToken();
				String state1=word.substring(name.length()+1,word.length());
				if(debugflag) System.out.println("state:"+state1);
				line=line+name+"\"]="+state1+";";
				out.println(line);
				if(debugflag) System.out.println(line);
			}
		}
	}
	//out.println("</script>");
}

public void showS()
{
		out.println("<script language=javascript>");
		for(int i=0;i<appnum;i++)
		{
		String Appname=(String)appD.elementAt(0+i*3);
		String Priname=(String)appD.elementAt(1+i*3);
		String Secname=(String)appD.elementAt(2+i*3);
		
		// script for restart functions
		out.println("function app_"+Appname+"(oper){");
		out.println("if(oper==\"restart\"){");
		out.println("}");
		out.println("else if(oper==\"start\"){");
		out.println("if ((parent.parent.loginName==\"\")||(parent.parent.loginName==null))");
		out.println("{	alert(\"Please login first!\");");
		out.println("return;}");
		out.println("if ((parent.parent.Password==\"\")||(parent.parent.Password==null))");
		out.println("{	alert(\"Password is null!\");");
		out.println("return;}");
		out.println("location.href=\"http://\"+location.hostname+\":8090/servlet/cics_hanodeMani?lname=\"+parent.parent.loginName+\"&passwd=\"+parent.parent.Password+\"&server=\"+location.hostname+\"&type=haapps5&flag=0\"+\"&next=/haappconf.html&app="+Appname+"&prin="+Priname+"&secn="+Secname+"\";");
		out.println("}");
		out.println("else if(oper==\"stop\"){");
		out.println("}");
		out.println("else if(oper==\"takeover\"){");
		out.println("}");
		out.println("}");
		}	
		out.println("</script>");
	
	out.println("<script language=javascript>");
	out.println("function showStatus(statusWin)	{");
	//initApp();
	//getS(statusEn);
	out.println("statusWin.document.writeln(\"<table border=0 width=300 height=300 cellspacing=0 cellpadding=0>\");");

	out.println("statusWin.document.writeln(\"<tr><td align=center>\");");
	out.println("statusWin.document.writeln(\"<table border=1 width=300 cellspacing=0 cellpadding=0>\");");
	out.println("statusWin.document.writeln(\"<tr><td width=125 align=center><img src=\\\"../../images/l_green.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_grey.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_blue.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_purple.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"</tr><tr>\");	");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>READY</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Unreachable</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>RMINOTREADY</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>HANOTREADY</font></td>\");");
	out.println("statusWin.document.writeln(\"</tr>\");	");
	out.println("statusWin.document.writeln(\"<tr><td width=125 align=center><img src=\\\"../../images/l_cyan.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_yellow.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_orange.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_black.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 align=center><img src=\\\"../../images/l_white.gif\\\" border=0></td>\");");
	out.println("statusWin.document.writeln(\"</tr><tr>\");	");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Run On Both HA nodes</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Run On Primary node</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Run On Secondary node</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Stop</font></td>\");");
	out.println("statusWin.document.writeln(\"<td width=125 height=10 align=center><font size=-3>Unknown</font></td>\");");
	out.println("statusWin.document.writeln(\"</tr>\");");
	out.println("statusWin.document.writeln(\"</tr></table>\");");
	out.println("statusWin.document.writeln(\"</td></tr>\");");

	// add write application status form 
	System.out.println("appnum="+appnum);
	
	for(int i=0;i<appnum;i++)
	{
		String Appname=(String)appD.elementAt(0+i*3);
		String Priname=(String)appD.elementAt(1+i*3);
		String Secname=(String)appD.elementAt(2+i*3);
		if(debugflag) System.out.println("Appname="+Appname+"; Priname="+Priname+"; Secname="+Secname);
		
		out.println("statusWin.document.writeln(\"<tr><td align=center><br>\");");
	
		out.println("statusWin.document.writeln(\"<form name=\\\""+Appname+"\\\">\");");
		out.println("statusWin.document.writeln(\"<div align=\\\"center\\\"><center><p><img src=\\\"../../images/day_nigh.gif\\\" width=\\\"300\\\" height=\\\"9\\\"></p>\");");
		// application status
		out.println("if((app[\""+Priname+"."+Appname+"\"]==1)&&(app[\""+Secname+"."+Appname+"\"]==1))");
		out.println("statusWin.document.writeln(\"</center></div><div align=\\\"center\\\"><center><p>&nbsp;&nbsp;&nbsp; <img src=\\\"../../images/l_cyan.gif\\\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"Appname\\\" size=\\\"20\\\" value=\\\""+Appname+"\\\" style=\\\"background-color: rgb(128,128,128); color: rgb(0,255,0)\\\">\");");
		out.println("else if((app[\""+Priname+"."+Appname+"\"]==1)&&(app[\""+Secname+"."+Appname+"\"]==0))");
		out.println("statusWin.document.writeln(\"</center></div><div align=\\\"center\\\"><center><p>&nbsp;&nbsp;&nbsp; <img src=\\\"../../images/l_yellow.gif\\\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"Appname\\\" size=\\\"20\\\" value=\\\""+Appname+"\\\" style=\\\"background-color: rgb(128,128,128); color: rgb(0,255,0)\\\">\");");
		out.println("else if((app[\""+Priname+"."+Appname+"\"]==0)&&(app[\""+Secname+"."+Appname+"\"]==1))");
		out.println("statusWin.document.writeln(\"</center></div><div align=\\\"center\\\"><center><p>&nbsp;&nbsp;&nbsp; <img src=\\\"../../images/l_orange.gif\\\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"Appname\\\" size=\\\"20\\\" value=\\\""+Appname+"\\\" style=\\\"background-color: rgb(128,128,128); color: rgb(0,255,0)\\\">\");");
		out.println("else if((app[\""+Priname+"."+Appname+"\"]==0)&&(app[\""+Secname+"."+Appname+"\"]==0))");
		out.println("statusWin.document.writeln(\"</center></div><div align=\\\"center\\\"><center><p>&nbsp;&nbsp;&nbsp; <img src=\\\"../../images/l_black.gif\\\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"Appname\\\" size=\\\"20\\\" value=\\\""+Appname+"\\\" style=\\\"background-color: rgb(128,128,128); color: rgb(0,255,0)\\\">\");");
		out.println("else");
		out.println("statusWin.document.writeln(\"</center></div><div align=\\\"center\\\"><center><p>&nbsp;&nbsp;&nbsp; <img src=\\\"../../images/afraid.gif\\\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"Appname\\\" size=\\\"20\\\" value=\\\""+Appname+"\\\" style=\\\"background-color: rgb(128,128,128); color: rgb(0,255,0)\\\">\");");
		
		
		out.println("statusWin.document.writeln(\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </p>\");");
		out.println("statusWin.document.writeln(\"</center></div><p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");
		//primary node status
		
/*		out.println("if(app[\"run."+Priname+"."+Appname+"\"]==1)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/smile.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");
		out.println("else if(app[\"run."+Priname+"."+Appname+"\"]==0)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/afraid.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");
*/		
		out.println("if(node[\""+Priname+"\"]==2)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_green.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Priname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else if(node[\""+Priname+"\"]==1)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_purple.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Priname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else if(node[\""+Priname+"\"]==0)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_blue.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Priname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_grey.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Priname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("statusWin.document.writeln(\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");

/*		out.println("if(app[\"run."+Secname+"."+Appname+"\"]==1)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/smile.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");
		out.println("else if(app[\"run."+Secname+"."+Appname+"\"]==0)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/afraid.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\");");
*/		
//		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/Computer.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Priname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("if(node[\""+Secname+"\"]==2)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_green.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Secname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else if(node[\""+Secname+"\"]==1)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_purple.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Secname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else if(node[\""+Secname+"\"]==0)");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_blue.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Secname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");
		out.println("else");
		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/l_grey.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"PriNode\\\" size=\\\"20\\\" value=\\\""+Secname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\" >\");");

//		out.println("statusWin.document.writeln(\"<img src=\\\"../../images/Computer.gif\\\" width=\\\"20\\\" height=\\\"20\\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\\\"text\\\" name=\\\"SecNode\\\" size=\\\"20\\\" value=\\\""+Secname+"\\\" style=\\\"border: medium none rgb(255,255,255)\\\"></p>\");");
		out.println("statusWin.document.writeln(\"<p>&nbsp;</p></form>\");");
		
		// for buttom restart
		out.println("statusWin.document.writeln(\"<div align=\\\"center\\\"><center><p>\");");
		//out.println("<input type=\"button\" value=\"  Start  \" name=\"start\" onclick=\""+Appname+"(&quot;start&quot)\">&nbsp;");
		//out.println("<input type=\"button\" value=\"   Stop  \" name=\"stop\" onclick=\""+Appname+"(&quot;stop&quot)\">&nbsp;&nbsp; ");
		out.println("statusWin.document.writeln(\"<input type=\\\"button\\\" value=\\\" Start On both Nodes \\\" name=\\\"start\\\" onclick=\\\"app_"+Appname+"(&quot;start&quot)\\\">&nbsp;&nbsp;\");");
		//out.println("statusWin.document.writeln(\"<input type=\\\"button\\\" value=\\\"Takeover\\\" name=\\\"takeover\\\" onclick=\\\"app_"+Appname+"(&quot;takeover&quot)\\\"></p>\");");
        out.println("statusWin.document.writeln(\"</center></div>\");");

		out.println("statusWin.document.writeln(\"</td></tr>\");");

	}
	
	out.println("statusWin.document.writeln(\"<tr><td>\");");
	out.println("statusWin.document.writeln(\"<table border=0 width=200 height=300 cellspacing=0 cellpadding=0>\");");
	out.println("statusWin.document.writeln(\"<tr>\");");
	out.println("statusWin.document.writeln(\"</td></tr>\");");
	out.println("statusWin.document.writeln(\"</table>\");");
	out.println("statusWin.document.writeln(\"</td></tr></table>\");");
	out.println("statusWin.document.clear();");
	out.println("statusWin.document.close();");
	out.println("}");
	out.println("</script>");
}

public void initApp()
{
	appnum=0;
	appD.removeAllElements();
	out.println("var app = new Array()");
	// read haresources file to get application list
	String filename="/etc/HAapps.conf";
	try {
		FileInputStream in = new FileInputStream("/etc/HAapps.conf");
		BufferedReader d = new BufferedReader(new InputStreamReader(in));
	if (d==null) return;

	String line = null;
		
	String nodes="";
	Vector el= new Vector();
	String HAappname = "";
	String HAnodepair = "";
	String PriNode = "";
	String SecNode = "";
      
	Vector nodeinfo=new Vector();
	
	while ((line=d.readLine())!=null)
	{
		line = line.trim();
		if (line.startsWith("#")) continue;
		StringTokenizer st = new StringTokenizer(line);
		if (st.countTokens()!=4) continue;
		HAappname = st.nextToken();
		HAnodepair = st.nextToken();
		PriNode = st.nextToken();
		SecNode = st.nextToken();
		try {
			if (PriNode!=null) {
				st = new StringTokenizer(PriNode,".");
				if(st.countTokens()!=0)	
					PriNode = st.nextToken();
			}
			if (SecNode!=null) {
				st = new StringTokenizer(SecNode,".");
				if(st.countTokens()!=0)	
					SecNode = st.nextToken();
			}
		}catch(Exception e1){};

		appnum++;
		if(debugflag) System.out.println("  in initApp: appnum="+appnum);
		//System.out.println("Primary:"+PriNode);
		//System.out.println("Secondary:"+SecNode);
		
		appD.addElement(HAappname);
		appD.addElement(PriNode);
		appD.addElement(SecNode);
		for(int i=0;i<nodeinfo.size();i++)
		{
			String ele=(String)nodeinfo.elementAt(i);
			if(!ele.equals(PriNode))
				nodeinfo.addElement(PriNode);
			if(!ele.equals(SecNode))
				nodeinfo.addElement(SecNode);
		}
		
		// Initialization for the HA application status:
		out.println("app[\""+PriNode+"."+HAappname+"\"]=0;");
		out.println("app[\""+SecNode+"."+HAappname+"\"]=0;");
//		out.println("app[\"run."+PriNode+"."+HAappname+"\"]=3;");
//		out.println("app[\"run."+SecNode+"."+HAappname+"\"]=3;");
	}
	out.println("var node =new Array()");
	for(int i=0;i<nodeinfo.size();i++)
		out.println("node[\""+(String)nodeinfo.elementAt(i)+"\"]=3;");
	in.close();
	d.close();
	}catch(Exception e) {
		System.out.println("Error while reading HAapp.conf file:"+e.toString());
	}
}
String trimHost(String s)
{
	if (s==null) return s;
	StringTokenizer st = new StringTokenizer(s,".");
	if (st.countTokens()==0) return s;
	return st.nextToken();
}

}

