import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.manipulate.*;

// last updated by wanglin,Aug. 24th, 2001 
public class CICS_NodeInstallServlet extends HttpServlet
{
boolean debugflag = false;
String[] rns = {"mon","hearbeat"};
String[] emon={"perl-Convert-BER-1.26-6.i386.rpm","perl-Period-1.20-6.i386.rpm","perl-Time-HiRes-01.20-6.i386.rpm","perl-TimeDate-1.08-2.i386.rpm","mon-0.38.15-1.i386.rpm"};
String[] eheart={"heartbeat-0.4.9-1.i386.rpm"};

String[] displayTypes = {"Sheet I"};

static Hashtable groupToHost = new Hashtable();

// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

	String oper=request.getParameter("oper");
	Resource rs = null;
	String server = "";
	int port = -1;
	int step = 1;

	String ln=request.getParameter("login");
	String pw=request.getParameter("pwd");

	try {
	step = Integer.parseInt(request.getParameter("step"));
	}catch(Exception ee){};

	try {
	server = InetAddress.getLocalHost().getHostName();
	port = 7001;
	}catch(Exception ee) {
		out.println("<html><head><title>Error Server</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	int rindex = -1;
	try {
		rindex = Integer.parseInt(request.getParameter("rname"));
	}catch(Exception e0) {};

	int[] entryIndex = null;
	// get the seleted packet index.
	String entries="";
	try {
		entries = request.getParameter("entries");
		if (entries!=null) {
			StringTokenizer st = new StringTokenizer(entries,"|");
			entryIndex = new int[st.countTokens()];
			for (int i=0;i<entryIndex.length;i++)
				entryIndex[i] = Integer.parseInt(st.nextToken().trim());
		}
	}catch(Exception e1){};

	String[] e=null; 
	if(rindex==0) 
		e=emon;
	else 
		e=eheart;
						  
	String hosts = null;
	String[] ehosts=null;
	try {
		hosts = request.getParameter("hosts");
		if(debugflag) System.out.println("hosts is:"+hosts);
		if (hosts!=null) {
		StringTokenizer st = new StringTokenizer(hosts,"|");
		ehosts = new String[st.countTokens()];
		for (int i=0;i<ehosts.length;i++)
			ehosts[i] = st.nextToken().trim();
		}

	}catch(Exception e3){};

    String detail="";						  
	try{						  
		detail=request.getParameter("detail");
	}catch(Exception e4){};
						  
	if (step==5)
		out.println("<BASE href=\"http://"+server+"/\">");

	out.println("<html>");
	out.println("<head>");
	out.println("<title>install HA software on nodes</title>");

	out.println("<script language=javascript>");
	out.println("function relocation(server,step,dir,form,ln,pw,oper)");
	out.println("{");
	out.println("var temp,temp1;");
	out.println("var i;");
	out.println("if (step==1)");
	out.println("{");
	out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall?step=2&rname=\"+form.object.selectedIndex+\"&login=\"+ln+\"&pwd=\"+pw+\"&oper=\"+oper;");
	out.println("}");

	out.println("else if(step==2)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp=\"\";");
	out.println("for(i=0;i<(form.elements.length-2);i++)");
	out.println("{");
	out.println("if (form.elements[i].checked)");
	out.println("if (temp.length!=0)");
	out.println("temp = temp+\"|\"+i;");
	out.println("else");
	out.println("temp = temp+i;");
	out.println("}");
	out.println("if(temp.length==0)");
	out.println("alert('You must check at least one packet!');");
	out.println("else {");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,3);");
	out.println("temp1=trim(temp1,3);");
	out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall\"+temp1+\"&entries=\"+temp+\"&login=\"+ln+\"&pwd=\"+pw+\"&oper=\"+oper;");
	//out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall\"+temp1+\"&entries=\"+temp;");
	out.println("}");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,1);"); 
	//out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall\"+temp1+\"&login=\"+ln+\"&pwd=\"+pw;");
	out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("else if(step==3)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp=\"\";");
	out.println("for(i=0;i<(form.elements.length-2);i++)");
	out.println("{");
	out.println("if (form.elements[i].checked)");
	out.println("if (temp.length!=0)");
	out.println("temp = temp+\"|\"+form.elements[i].name;");
	out.println("else");
	out.println("temp = temp+form.elements[i].name;");
	out.println("}");
	out.println("if(temp.length==0)");
	out.println("alert('You must check at least one node!');");
	out.println("else {");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,4);");
	out.println("temp1=trim(temp1,4);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1+\"&hosts=\"+temp+\"&login=\"+ln+\"&pwd=\"+pw+\"&oper=\"+oper;");
	out.println("}");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,2);"); 
	//out.println("location.href=\"http://\"+server+\":8100/servlet/cics_nodeinstall\"+temp1+\"&login=\"+ln+\"&pwd=\"+pw;");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1;");
	out.println("}");
	out.println("}");
	
	out.println("else if(step==4)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");

	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,5);"); 
	out.println("var l=0;");
	out.println("if(!form1.chk.checked)");
	out.println("l=1;");
	out.println("else l=0;");
	//out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1+\"&hosts=\"+temp+\"&login=\"+ln+\"&pwd=\"+pw+\"&oper=\"+oper+\"&detail=\"+l;");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1+\"&detail=\"+l;");

/*	out.println("var l=0;");
	out.println("if(!form1.chk.checked)");
	out.println("l=1;");
	out.println("else l=0;");
	out.print("location.href=\"http://\"+server+\":8090/servlet/cics_hanodeMani?lname=\"+ln+\"&passwd=\"+pw+\"&oper=\"+oper+\"&server=\"+location.hostname+\"&type=nodeinstall\"");
	out.println("+\"&flag=\"+l");
	out.print("+\"&rindex="+rindex+"&entries="+entries+"&hosts="+hosts+"\"");
	out.print(";\n");
*/	
	//out.println("if(!form1.chk.checked)");
	//out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall?login=\"+ln+\"&pwd=\"+pw;");
	
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,3);"); 
	//out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1+\"&login=\"+ln+\"&pwd=\"+pw;");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_nodeinstall\"+temp1;");
	out.println("}");
	out.println("}");
	out.println("else if(step==5)");
	out.println("{");
	out.println("var l=0;");
	
	if(step==5)
		if(detail.equals("0"))
			out.println("l=0;");
		else
			out.println("l=1;");
	out.print("location.href=\"http://\"+server+\":8090/servlet/cics_hanodeMani?lname=\"+ln+\"&passwd=\"+pw+\"&oper=\"+oper+\"&server=\"+location.hostname+\"&type=nodeinstall\"");
	out.println("+\"&flag=\"+l");
	out.print("+\"&rindex="+rindex+"&entries="+entries+"&hosts="+hosts+"\"");
	out.print(";\n");
	out.println("}");
				
	out.println("}");

	out.println("function replaceStep(s,step)");
	out.println("{");
	out.println("var index = s.indexOf('=',0);");
	out.println("var ns;");
	out.println("ns = s.substring(0,index+1)+step+s.substring(index+2,s.length);");
	out.println("return ns;");
	out.println("}");

	out.println("function trim(s,step)");
	out.println("{");
	out.println("var index = 0;");
	out.println("var i;");
	out.println("for (i=0;i<(step-1);i++)");
	out.println("index = s.indexOf('&',index+1);");
	out.println("if (index==-1)");
	out.println("return s;");
	out.println("return s.substring(0,index);");
	out.println("}");
	
	out.println("</script>");
	if (step<5)
	{
		out.println("</head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center>\n");
	}
	
	switch (step)
	{
	case 1:
		out.println("<form>\n");
		out.println("<br><table cellspacing=4 cellpadding=2 align=center border=2 nowrap>\n");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=1 nowrap><font color=#ffffff size=5><b><i>Select Installed part</i></b></font></td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<font size=+3>");
		out.println("<tr><td bgcolor=#f0f000 align=center nowrap><select name=object size=1 RpGetType=complex RpSetType=complex>");
		for (int i=0;i<rns.length;i++)
		{
			if (i==rindex)
				out.println("<option selected>"+rns[i]);
			else
				out.println("<option>"+rns[i]);
		}
		out.println("</select>\n");
		out.println("</td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=center nowrap><input type=button value=\"Next\" onclick=\'relocation(\""+server+"\","+step+",true,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'></td></tr>");
		out.println("</font>");
		out.println("</table></form>");
		break;
	case 2:
		String[] eNames=null;
		
		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Select HA Software packets</b></i></font></td></tr><tr><td></td></tr><tr>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Packet Name</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
		out.println("</tr>");
		if(rindex==0)
		{
			eNames=emon;
		}
		else if(rindex==1)
		{
			 eNames=eheart;
		}
		for (int i=0;i<eNames.length;i++)
		{
			out.println("<tr>");
			out.println("<td nowrap>"+eNames[i]+"</td>");
			
			boolean checked = false;
			if (entryIndex!=null)
			{
				for (int ii=0;ii<entryIndex.length;ii++)
				{
					if (entryIndex[ii]==i) {
						checked = true;
						break;
					}
				}
			}	
			if (checked)
				out.println("<td nowrap><input type=checkbox name=chk"+i+" checked></td>");
			else
				out.println("<td nowrap><input type=checkbox name=chk"+i+"></td>");
			out.println("</tr>");
		}
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=3 nowrap>");
		//out.println("<input type=button lue=Back onClick=\'relocation(\""+server+"\",2,false,this.form)\'>");
		out.println("<input type=button value=\"back\" onclick=\'relocation(\""+server+"\","+2+",false,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",2,true,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;	

	case 3:
		GetCurrentValueDemo demo = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_NodeLists",server,port);		
		try {
			Thread.sleep(100);
		}catch(Exception eee){};
		int kk = 0;
		for (kk=0;kk<10;kk++)
		{
			if (demo.over)
				break;
			try {
			Thread.sleep(1000);
			}catch(Exception exp){};
		}	
		if (kk==10) {
			out.println("<br><h2>"+server+" Not reachable!</h2>");
			break;
		}

		if (!demo.success)	
		{
			out.println("<br><h2>Error:"+demo.errMessage+"</h2>");
			break;
		}

		Vector dv = null;
		try {
		dv = (Vector)demo.value.elementAt(0);
		}catch(Exception ed){};
		if (dv==null) {
			out.println("<br><h2>Error: no hosts available!</h2>");
			break;
		}
		Enumeration hostEn = dv.elements();
		
		ResourceTable rs0;
		try {
			rs0 = (ResourceTable)Class.forName("CLUSTERPROBE.resources.Cluster_NodeLists").newInstance();
		}catch(Exception re) {
			out.println("<br><h2>Error:"+re.toString()+"</h2>");
			break;
		}

		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Select hosts</b></i></font></td></tr><tr><td></td></tr><tr>");
		String[] eeNames = rs0.getEntryNames();
		for (int i=0;i<eeNames.length;i++)
			out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>"+eeNames[i]+"</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
		out.println("</tr>");
		while (hostEn.hasMoreElements())
		{
			ResourceTableData data = (ResourceTableData) hostEn.nextElement();
			Vector vt = data.getRecord();
			if (((Integer)vt.elementAt(4)).intValue()!=0)
				continue;
			out.println("<tr>");
			for (int i=0;i<vt.size();i++)
				out.println("<td nowrap>"+vt.elementAt(i)+"</td>");
			String hostname = (String) vt.elementAt(1);
			if (hosts!=null&&(hosts.indexOf(hostname))!=-1) 
				out.println("<td nowrap><input type=checkbox name=\""+hostname+"\" checked></td>");
			else 
				out.println("<td nowrap><input type=checkbox name=\""+hostname+"\"></td>");
			out.println("</tr>");
		}
		
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=3 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",3,false,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",3,true,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;
	case 4:
		// make sure the nodes and packets.
		// call manipulate file to do the installing job on nodes.
		out.println("</head>");
		out.println("<frameset rows=\"0,*\">");
		out.println("<p>&nbsp;</p>");
		out.println("<form name=\"form1\">");
		
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>confirm</b></i></font></td></tr><tr><td></td></tr><tr>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Packet Name</b></font></td>");
		out.println("</tr>");
		for(int i=0;i<entryIndex.length;i++)
		{
			out.println("<tr>");
			out.println("<td nowrap>"+e[i]+"</td>");
			out.println("</tr>");
		}
		out.println("<tr><td></td></tr>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
		for(int i=0;i<ehosts.length;i++)
		{
			out.println("<tr>");
			out.println("<td nowrap>"+ehosts[i]+"</td>");
			out.println("</tr>");
		}
		out.println("<tr><td></td></tr>");
		
		
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Detail flag</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
		out.println("<tr>");
		out.println("<td nowrap>Show Detail</td>");
		out.println("<td nowrap><input type=checkbox name=chk></td>");
		out.println("</tr>");

		
		out.println("<tr><td align=left colsapn=3 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",4,false,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("<input type=button name=finish value=Finish onClick=\'relocation(\""+server+"\",4,true,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\")\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		
		break;
	case 5:
		out.println("</head>");
		out.println("<p>&nbsp;</p>");
		out.println("<p>&nbsp;</p><p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Please Wait ...</p>");
		out.println("<script language=javascript>");
		out.println("relocation(\""+server+"\",5,true,this.form,\""+ln+"\",\""+pw+"\",\""+oper+"\");");
		out.println("</script>");

		break;
		
	}
	out.println("</center></body></html>");
	out.close();
}

String replaceStep(String s, int step)
{
	if (s==null) return null;
	int index = s.indexOf("=");
	if (index==-1) return s;
	String sss = s.substring(0,index+1)+step+s.substring(index+2,s.length());
	return sss;
}


}
