/*
 * @(#) Cluster_HANode_conf 01/7/18
 */ 

//package JESSIC.resources;
package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.*;

/**
 * Define the resource format of Cluster-HANode_conf
 */

//modified from Cluster_Workstation_CPUState
public class Cluster_HANode_conf 
{
	String filename = "";
	//----for file ha.cf
	String serial="";
	String watchdog="";
	boolean Flag_wd=false;
	String udp="";
	String keepalive="2";
	String deadtime="10";
	String hopfudge="1";
	String baud="19200";
	String udpport="694";
	boolean Flag_NF=false;
	String nice_failback="false";
	String node1="";
	String node2="";
	
	//----for file haresources
	String nodename="";
	String Ipaddr="";
	String HAapp="";

	//----for file Authkeys
	String authkey="sha1";	

	//----for file mon.cf
	String cfbasedir="";
	String alertdir="";
	String mondir="";
	String maxprocs="20";
    	String histlength="100";
	String randstart="30";
	String hostgroup1="";
	String hostgroup2="";
	
	public Cluster_HANode_conf()
	{
		initData();
	}
	public void initData()
	{
		filename = "";
	//----for file ha.cf
		serial="";
		watchdog="";
		Flag_wd=false;
		udp="";
		keepalive="2";
		deadtime="10";
		hopfudge="1";
		baud="19200";
		udpport="694";
		Flag_NF=false;
		nice_failback="false";
		node1="";
		node2="";
	
	//----for file haresources
		nodename="";
		Ipaddr="";
		HAapp="";
	
	//----for file Authkeys
		authkey="sha1";
	
	//----for file mon.cf
		cfbasedir="";
		alertdir="";
		mondir="";
		maxprocs="20";
		histlength="100";
		randstart="30";
		hostgroup1="";
		hostgroup2="";
	}
	public void setFilename(String ref)
	{
		filename=ref;
		return;
	}	

	//----for file ha.cf
	public void setSerial(String ref)
	{
		serial=ref;
		return;
	}

	public void setWatchdog(String ref)
	{
		Flag_wd=true;
		watchdog="";
		if(!ref.trim().equals(""))
			watchdog=ref;
		else
			Flag_wd=false;
		return;
	}

	public void setUdp(String ref)
	{
		udp=ref;
		return;	
	}

	public void setKeepalive(String ref)
	{
		keepalive=ref;
		return;
	}

	public void setDeadtime(String ref)
	{
		deadtime=ref;
		return;	
	}

	public void setHopfudge(String ref)
	{
		hopfudge=ref;
		return;
	}
	
	public void setBaud(String ref)
	{
		baud=ref;
		return;
	}

	public void setUdpport(String ref)
	{
		udpport=ref;
		return;
	}

	public void setNice_failback(String ref)
	{
		Flag_NF=true;
		nice_failback="";
		if(ref.equals("on"))
			nice_failback="on";
		else if (ref.equals("off"))
			nice_failback="off";
		else
			Flag_NF=false;
		return;
	}

	public void setNode1(String ref)
	{
		node1=ref;
		return;
	}

	public void setNode2(String ref)
	{
		node2=ref;
		return;
	}

	//----for file haresources
	public void setHAapp(String ref)
	{
		HAapp=ref;
		return;
	}

	public void setIpaddr(String ref)
	{
		Ipaddr=ref;
		return;
	}

	public void setNodename(String ref)
	{
		nodename=ref;
		return;
	}
	
	//---for file Authkeys
	public void setAuthkey(String ref)
	{
		authkey=ref;
		return;
	}
	
	//--- for file mon.cf
	public void setCfbasedir(String ref)	{
		cfbasedir=ref;
		return;
	}
	public void setAlertdir(String ref)
	{
		alertdir=ref;
		return;
	}
	public void setMondir(String ref)
	{
		mondir=ref;
		return;
	}
	public void setMaxprocs(String ref)
	{
		maxprocs=ref;
		return;
	}
	public void setListlength(String ref)
	{
		histlength=ref;
		return;
	}
	public void setRandstart(String ref)
	{
		randstart=ref;
		return;
	}
	public void setHostgroup1(String ref)
	{
		hostgroup1=ref;
		return;
	}
	public void setHostgroup2(String ref)
	{
		hostgroup2=ref;
		return;
	}
	
	//----for file ha.cf
	public String getSerial()
	{
		return serial;
	}
	public boolean getFlag_wd()
	{
		return Flag_wd;
	}
	public String getWatchdog()
	{
		return watchdog;
	}

	public String getUdp()
	{
		return udp;
	}
	public String getKeepalive()
	{
		return keepalive;
	}

	public String getDeadtime()
	{
		return deadtime;
	}
	public String getHopfudge()
	{
		return hopfudge;
	}
	
	public String getBaud()
	{
		return baud;
	}
	public String getUdpport()
	{
		return udpport;
	}
    
	public boolean getFlag_NF()
	{
		return Flag_NF;
	}

	public String getNice_failback()
	{
		return	nice_failback;
	}
	public String getNode1()
	{
		return node1;
	}
	public String getNode2()
	{
		return node2;
	}

	//----for file haresources
	public String getHAapp()
	{
		return HAapp;
	}

	public String getIpaddr()
	{
		return Ipaddr;
	}
	public String getNodename()
	{
		return nodename;
	}
	
	//---for file Authkeys
	public String getAuthkey()
	{
		return authkey;
	}
	
	//--- for file mon.cf
	public String getCfbasedir()
	{
		return cfbasedir;
	}
	public String getAlertdir()
	{
		return alertdir;
	}
	public String getMondir()
	{
		return mondir;
	}
	public String getMaxprocs()
	{
		return maxprocs;
	}
	public String getHistlength()
	{
		return histlength;
	}
	public String getRandstart()
	{
		return randstart;
	}
	public String getHostgroup1()
	{
		return hostgroup1;
	}
	public String getHostgroup2()
	{
		return hostgroup2;	
	}
	public String getFilename()
	{
		return filename;	
	}
	public void writeToFile()
	{
		String dir="/etc/HAscript/tmp/";
		String file=dir+getFilename();
		try{
		 File outputFile = new File(file);
       		 FileWriter out = new FileWriter(outputFile);
		
		try{
			if(getFilename().equals("authkeys"))
			{	
				out.write("auth 1\n");
				String tm="1 "+getAuthkey()+" ha!\n";
				out.write(tm);
			}
			else if (getFilename().equals("ha.cf"))
			{
				out.write("# 	File to write other messages to\n");
				out.write("logfile /var/log/ha-log\n");
				out.write("#	Facility to use for syslog()/logger\n");
				out.write("logfacility	local0\n");
				//out.write("\n");
				out.write("#	keepalive: how many seconds between heartbeats\n");
				out.write("keepalive "+getKeepalive()+"\n");
				out.write("#	deadtime: seconds-to-declare-host-dead\n");
				out.write("deadtime "+getDeadtime()+"\n");
				out.write("#	hopfudge maximum hop count minus number of nodes in config\n");
				out.write("hopfudge "+getHopfudge()+"\n");
				out.write("#	serial	serialportname ...\n");
				out.write("serial	"+getSerial()+"\n");
				out.write("#	Baud rate for serial ports...\n");
				out.write("baud	"+getBaud()+"\n");
				out.write("#	What UDP port to use for communication?\n#udpport	694\n");
				out.write("#	What interfaces to heartbeat over?\n");
				out.write("udpport	"+getUdpport()+"\n");
				out.write("#udp	eth1\n");
				out.write("udp "+getUdp()+"\n");
				out.write("#	Watchdog is the watchdog timer.  If our own heart doesn't beat for\n");

				out.write("#	a minute, then our machine will reboot.\n");
				out.write("watchdog "+getWatchdog()+"	\n");
				out.write("\n");
				out.write("#	Tell what machines are in the cluster\n");
				out.write("#	node	nodename ...	-- must match uname -n\n");
				out.write("node "+getNode1()+"\n");
				out.write("node "+getNode2()+"\n");
			}
			else if (getFilename().equals("mon.cf"))
			{
				out.write("#global options\n");
				out.write("cfbasedir  ="+getCfbasedir()+"\n");
				out.write("alertdir   ="+getAlertdir()+"\n");
				out.write("mondir  ="+getMondir()+"\n");
				out.write("maxprocs  ="+getMaxprocs()+"\n");
				out.write("histlength = "+getHistlength()+"\n");
				out.write("randstart ="+getRandstart()+"\n");
				out.write("#group definitions\n");
				out.write("hostgroup "+getHostgroup1()+"\n");
				out.write("hostgroup "+getHostgroup2()+"\n");
			}
			else if(getFilename().equals("haresources"))
			{
				out.write(getNodename()+"  "+getIpaddr()+"  "+getHAapp()+"  ");
				out.write("\n");
			}
			else
			{
				System.out.println("Wrong filename");
			}
					
		}catch(IOException e){
			System.out.println("Exception:"+e);
		}
		//out.write("end");
        out.close();
		}catch(IOException e){
			System.out.println("Exception:"+e);
		}
	}
	

}
