/*
 * @(#) Cluster.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.GUI;
 
import java.net.URL;
import java.util.*;
import com.sun.java.swing.ImageIcon;
/**
 * Store all configuring information about the cluster .
 * 
 * @author Jimmy Liang
 * @version 1.00 12/3/98
 */

public class Cluster extends Object {
	private String name;
	final static int READY=1;
	final static int ERROR=2;
	final static int WARNING=3;
	public static ImageIcon READY_ICON;
	public static ImageIcon ERROR_ICON;
	public static ImageIcon WARNING_ICON;

	public Cluster() {};

	public int getWorkstationCount() {
		return 16;
	}

//test data
static int[] status = {1,1,3,1, 3,1,2,1, 1,2,1,1, 1,3,1,1};
	public ImageIcon toIcon(int index) {
		switch(status[index])
		{
		case READY:
			return READY_ICON;
		case ERROR:
			return ERROR_ICON;
		case WARNING:
			return WARNING_ICON;
		default:
			return null;
		}
	}

//for test
static String[] desc = {"Ready","Ready","Overload","Ready", "Swap_Closing_Full","Ready","Unreadch","Ready", "Ready","Unreach","Ready","Ready", "Ready","Package_Losing","Ready","Ready"};
static String[] names = {"c1","c2","c3","c4","c5","c6","c7","c8","c9","c10","c11","c12","c13","c14","c15","c16"};

	public String statusToString(int index) {
		return desc[index];
	}

	public String nodeName(int index) {
		return names[index];
	}
}	
		
		
	
	

