/*
 * @(#) ErrorMessage.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.GUI;
 
/**
 * Define all error id with its descrition.
 * 
 * @author Jimmy Liang
 * @version 1.00 12/22/98
 */

public class ErrorMessage extends Object
{
	final static int NODE_NOT_EXISTED = 1;
	final static int NODE_EXISTED = 2;

	public static String getMessage(int id) 
	{
		switch(id)
		{
		case NODE_NOT_EXISTED:
			return "The workstation you mentioned do not contain in this cluster!";
		case NODE_EXISTED:
			return "The workstation you mentioned has been already included in this cluster";
		}
		return null;
	}
}
