/*
 * @(#) ManageServerII.java 99/5/22
 */

package CLUSTERPROBE.Server;
 
import java.util.EventListener;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;
import CLUSTERPROBE.message.EventTransceiver;
import CLUSTERPROBE.resources.*;

/**
 * This class run as a deamon on the management server which responsible to
 * establish and maintainconnection with client. And for each connect, a thread
 * will be started to receive , process request package from the client of the c * connection, and also forwards the corresponding events to client.
 *
 * @author Jimmy Liang
 * @version 1.00 5/22/99
 */

public class ManageServerII extends Thread 
{
	public static void main(String[] args)
	{
 System.setSecurityManager(new CLUSTERPROBE.resources.MySecurityManager());

		ManipulateServer os = new ManipulateServer(7003);
		System.out.println("ManipulateServer on 7003");
		os.start();
		ResourceServer rs = new ResourceServer(7005);
		System.out.println("ResourceServer also on 7005");
		rs.start();
		CServer cs = new CServer(7004);
		System.out.println("CServer on 7004");
		cs.start();
}

}
			
