/*
 * demo for pull mechanism
*/
#include "local.h"

extern pull();
extern printTable();

main(int argc, char* argv[])
{
  struct table tb, *tb_ptr;   /* tables which store data values     */
  int i, tables_num = 0;      /* No. of tables                      */
  struct resource_info info;  /* resource information               */
  u_short rid = CPUSTATE;
  
  if (argc != 2) {            /* Expect name of host on cmd line      */
    fprintf(stderr,"usage: %s server \n",argv[0]);
    exit(1);
  }

  tables_num = pull(argv[1],rid, &tb);

  if (tables_num>0)
  {
    getResource(&info,rid);
    for (i=0;i<10;i++)
      fprintf(stderr,"-");
    fprintf(stderr,"\n");
    for (i=0;i<info.value_num;i++)
     fprintf(stderr,"%s  ",info.value_desc[i]);
    fprintf(stderr,"\n");
    for (i=0;i<10;i++)
      fprintf(stderr,"-");
    fprintf(stderr,"\n\n");

    tb_ptr = &tb;
    for (i=0;i<tables_num;i++)
    {
      printTable(tb_ptr);
      tb_ptr = tb_ptr->nextTable;
    }
  }

}

