/*
 * @(#) ManipulateArgument.java 99/4/15
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.manipulate;
 
import java.util.Hashtable;

/**
 * Define the argument.
 *
 * @author Jimmy Liang
 * @version 1.00 4/15/99
 */

public class ManipulateArgument extends Object implements java.io.Serializable 
{
	String desc = null;
	Object defaultValue = null;
	Object value = null;

	public ManipulateArgument(String desc, Object defaultValue)
	{
		this.desc = desc;
		this.defaultValue = defaultValue;
	}

	public String getDesc()
	{
		return desc;
	}
	
	public Object getDefaultValue()
	{
		return defaultValue;
	}

	public Object getValue()
	{
		return value;
	}

	public void setDesc(String d)
	{
		desc = d;
	}

	public void setDefaultValue(Object d)
	{
		defaultValue = d;
	}

	public void setValue(Object v)
	{
		value = v;
	}

}	

