/*
 * @(#) Manipulation.java 99/3/21
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.manipulate;
 
import java.util.Hashtable;
import CLUSTERPROBE.security.Password;

/**
 * Define the manipulation which will be executed by target nodes.
 *
 * @author Jimmy Liang
 * @version 1.00 3/21/99
 */

public abstract class Manipulation extends Object implements java.io.Serializable 
{
	public abstract void operate(Hashtable agvs, Password pw);

	public abstract boolean isAlive();

	public abstract Object getResult();

	public abstract long getTimeout();

	public abstract boolean isSuccess();
}
