/*
 * @(#)ScriptManipulation.java 
 */

package CLUSTERPROBE.manipulate;
 
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import CLUSTERPROBE.security.*;

/**
 * Define the script operations.
 */

public class ScriptManipulation extends Manipulation
{
	long timeOut = 5000;
	String script = null;
	String result = null;
	boolean success = false;
	Process p = null;
	BufferedReader in, err;

	public ScriptManipulation(String s)
	{
		if (s.indexOf("@")!=-1)
		{
			try {
			script = s.substring(0,s.indexOf("@"));	
			timeOut = Long.parseLong(s.substring(s.indexOf("@")+1,s.length()));
			}catch(Exception e)
			{};
		}
		else
			script = s;
	}

	public void operate(Hashtable agvs, Password pw)
	{
		if (Exec.HELPER==null)
			Exec.HELPER = "/usr/sbin/helper";
		String runScript = getRunScript(agvs);
		System.out.println("in ScriptManipulation: runScript is:"+runScript);
		StreamGroup group = Exec.exec(runScript,pw);
		System.out.println("StreamGroup is:"+group);
		if (group==null) {
			success = false;
			p = null;
			result = " Error: can't start process in java method";
			return;
		}

		p = group.p;
		in =  group.id;
		err = group.ed;
	}

	public String getRunScript(Hashtable args)
	{
		StringBuffer strb = new StringBuffer();
		for (int i=0; i<script.length();i++)
		{
			char c = script.charAt(i);
			if (c!='$')
			{
				strb.append(c);
				continue;
			}
			
			StringBuffer ss = new StringBuffer();
			ss.append(c);
			while (true)
			{
				i++;
				if (i==script.length())
					break;
				c = script.charAt(i);
				if (c==' ')
					break;
				ss.append(c);
			}	
			String key = new String(ss);
			ManipulateArgument arg = (ManipulateArgument) args.get(key);
			if (key!=null)
			{
				String value = null;
				if (arg.getValue()!=null) 
					value = (String) arg.getValue();
				if (value==null)
				{
					value = (String) arg.getDefaultValue();
					if (value!=null)
						strb.append(value);
				}
				else
					strb.append(value);
			}
			strb.append(" ");
		}
		return new String(strb);
	}

	public boolean isAlive()
	{
		if (p==null) return false;
		try {
			int ev = p.exitValue();
			//if (ev!=0&&ev!=65280)
			if (ev==65280)
			{
				String line = err.readLine();
				if (line==null||line.length()==0)
					ev = 0;
			}
System.out.println(ev);

			if (ev!=0)
			{
				success = false;
				StringBuffer strb = new StringBuffer();
				while (true)
				{
					String line = err.readLine();
					if (line==null) break;
					strb.append(line+"\n");
				}
				result = new String(strb);
			}
			else
			{
				success = true;
				StringBuffer strb = new StringBuffer();
				while (true)
				{
					String line = in.readLine();
					if (line==null) break;
					strb.append(line+"\n");
				}
				result = new String(strb);
			}
			return false;
		}catch(Exception e) {
			return true;
		}
	}
		
	public Object getResult() {
		if (result==null) return result;
		int count = result.length();
		if (count<=8196) return result; 
		Vector vt = new Vector();
		int sendCount = 0;
		while (sendCount<count)
		{
			if (count>(sendCount+8192))
				vt.addElement(result.substring(sendCount,sendCount+8192));
			else
				vt.addElement(result.substring(sendCount,count-1));
			sendCount+=8192;
		}
		return vt;
	}

	public long getTimeout() {
		return timeOut;
	}

	public boolean isSuccess() {
		return success;
	}

	public static void main(String[] args)
	{
		String s = "/bin/ls -l";
		if (args.length>0)
		{
			s = args[0];
		}
	
		ScriptManipulation opt = new ScriptManipulation(s);
		opt.operate(new Hashtable(), new Password(null, null));

		long time = 0;
		while (true)
		{
			try {
			Thread.sleep(500);
			}catch(Exception e) {};
			time+=500;
			
			if (opt.isAlive())
				if (time>opt.getTimeout())
				{
					System.out.println("Time out");
					break;
				}
				else
					continue;
				
			if (opt.isSuccess())
				System.out.println(" The result is:"+opt.getResult());
			else
				System.out.println(" Error: "+ opt.getResult());			
			break;
		}
	}		

			
}
