/*
 * @(#) EventHandler.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.EventListener;

/**
 * This interface is an extension of the java.util.EventListener interface
 * that adds a handleEvent() method. Then the coming events will trigger 
 * this method inside the registered handlers.
 *
 * @author Jimmy Liang
 * @version 1.00 12/20/98
 */

public interface EventHandler extends EventListener {
	public void handleEvent(JessicEvent e);
}
