/*
 * @(#) ResourceRefreshOperator.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Vector;

/**
 * This interface is the basic interface for operating resource refreshing
 * data.
 *
 * @author Jimmy Liang
 * @version 1.00 12/23/98
 */

public interface ResourceRefreshOperator
{
	public void operate(Vector data, Object location);
	public String[] getInterestResources();
	public void operateError(ErrorEvent e);
}
