/*
 * @(#) ResourceTableData.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.*;

/**
 * Define the format of the table resource data 
 *
 * @author Jimmy Liang
 * @version 1.00 12/21/98
 */

public class ResourceTableData extends ResourceData
{
	Vector record = null;
	Object key;

	public  ResourceTableData(String rn)
	{
		super(rn,ResourceRefreshEvent.REFRESHRECORD);
	}

	public ResourceTableData(String rn,Object k,Vector v)
	{
		super(rn,ResourceRefreshEvent.REFRESHRECORD);
		setRecord(v);
		setKey(k);
	}
		
	public void setKey(Object k) {
		key = k;
	}

	public Object getKey() {
		return key;
	}

	public void setRecord(Vector v)
	{
		record = v;
	}

	// get record
	public Vector getRecord()
	{
		return record;
	}	

}
		
		
