
/* %Z% %M%, Release %R%.%L%, %E%,%U% */ 

import java.io.*;
import java.util.*;

public class DoIt{

	protected String ErrMsg;
	protected String Result;
	protected DataInputStream CrtStream;
	protected Process df_proc;
	//DestroyProc p2;

	/** The method can execute command and return full error message*/

	public synchronized boolean runcmd(String command,int timeout) {

		int i,j;
		boolean isCorrect=false;
		Runtime myrun=Runtime.getRuntime();
		String[] cmd=new String[3];
		cmd[0]="/bin/sh";
		cmd[1]="-c";
		cmd[2]=command;
System.out.println("DoIt: " + cmd[2]);

		try {
			df_proc=myrun.exec(cmd);
			if (timeout == -1)
				return true;

			for( i=0;i<(timeout/100);i++)
			{
				try {
					df_proc.exitValue();
					break;
				} 
				catch (IllegalThreadStateException x) {
				};
				try {
					Thread.sleep(100);
				} 
				catch(InterruptedException e) {
					//Const.errorMessage = e.toString();
					return false;
				}
			}
			if (i==(timeout/100))
			{
				ErrMsg = "The process was destroyed for timeout.";
				//Const.errorMessage = ErrMsg;
				df_proc.destroy();
			}
			else 
			{
				if (df_proc.exitValue()==0)
					isCorrect = true;
			}
		} 
		catch (Exception e){
			e.printStackTrace();
			ErrMsg = e.toString();
			//Const.errorMessage = ErrMsg;
			isCorrect = false;
		}
		if (!isCorrect)
		{
			if (ErrMsg == null)
				ErrMsg = getErrMsg();
			//Const.errorMessage = ErrMsg;
		}
		return isCorrect;
	}

	public String getErrMsg() {
		if (ErrMsg != null)
			return ErrMsg;
		String errMsg;
		try{
			InputStream err=df_proc.getErrorStream();
			int lene=err.available();
			if (lene < 1)
				return ("");
			DataInputStream errmsg=new DataInputStream(err);
			byte[] b=new byte[lene];
			try {
				errmsg.readFully(b);
			} 
			catch (EOFException x) {
			}
			//errMsg="exitValue is :"+df_proc.exitValue()+"\n"+"error :\n"+new String(b);
			errMsg=new String(b);
			errmsg.close();
			System.out.println("ERROR: "+errMsg);
		} 
		catch (IOException e){
			errMsg = e.toString();
			System.out.println("ERROR: "+errMsg);
		}
		return errMsg;
	}

	public String getResult() {
		try{
			InputStream crt=df_proc.getInputStream();
			int lenc=crt.available();
			if (lenc<1)
				return "";
			else {
				CrtStream=new DataInputStream(crt);
				byte[] b=new byte[lenc];
				try {
					CrtStream.readFully(b);
				} 
				catch (EOFException x) {
				}
				CrtStream.close();
				Result=new String(b);
				System.out.println("RESULT: "+Result);
			}
		} 
		catch (Exception e){
			return e.toString();
		}
		return Result;
	}

	public DataInputStream getCrtStream() {
		if (df_proc==null) return null;
		InputStream crt=df_proc.getInputStream();
		CrtStream=new DataInputStream(crt);
		return CrtStream;
	}

	public static void main(String[] arg) {
		DoIt exe = new DoIt();
		exe.runcmd("/cluster/csms/sbin/cleanfile.sh /cluster/csms/temp/rc.tcpip.tmp", 3000);
		System.out.println(exe.getResult());
		System.out.println(exe.getErrMsg());
	}

}

