/*
 * @(#) NodeRMIImpl.java 99/1/15
 */

package CLUSTERPROBE.rmi;
 
import java.rmi.*;
import java.util.*;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.server.RemoteServer;
import java.net.*;
import java.io.*;

import CLUSTERPROBE.resources.*;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.MonitorThread;
import CLUSTERPROBE.manipulate.*;

/**
 * 
 * Start the agent from a thread
 */

public class StartThread extends Thread
{
	public StartThread()
	{};

	public void run()
	{
		boolean DebugFlag = true;
		if(DebugFlag) System.out.println("In rmi/StartThread Thread...");
		try{
		String localName = InetAddress.getLocalHost().getHostAddress();
		String name = "rmi://"+localName+":3000/agent";
		NodeRMIImpl obj = new NodeRMIImpl();
		System.out.println("Create agent, binding.....");
		Naming.rebind(name,obj);
		System.out.println("Remote Agent ready....");
		}catch(Exception e) {
			System.out.println("Caught exception whil registrating:"+e.toString());
		}
		if(DebugFlag) System.out.println("End of rmi/StartThread Thread.");
	}
}
				
				
