//Author: WangLin
//Last modified : 01/08/06
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.*;

//modified from CICS_HAnodeConf

public class CICS_HAappConf extends HttpServlet
{
	boolean debugflag = false;
	String appname="";
	String nodepair="";
	String prinode="";
	String secnode="";
	String hostgroup="";
	String montime="";
	String monfile="";
	String workdayF="";
	String workdayT="";
	String workhourF="";
	String workhourT="";
	String alertscript="";
	String alertmail="";
	String alerttime="";
	String haappkey="";
	String haappip="";
	String runcommand="";
	String filename="";

// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

	//String rname = request.getParameter("rname").trim();
	String rname = "CLUSTERPROBE.resources.Cluster_HAApp_conf";
	 appname=request.getParameter("ref1").trim();
	 nodepair=request.getParameter("ref2").trim();
	 prinode=request.getParameter("ref3").trim();
	 secnode=request.getParameter("ref4").trim();
	 hostgroup=request.getParameter("ref5").trim();
	 montime=request.getParameter("ref6").trim();
	 monfile=request.getParameter("ref7").trim();
	 workdayF=request.getParameter("ref8").trim();
	 workdayT=request.getParameter("ref9").trim();
	 workhourF=request.getParameter("ref10").trim();
	 workhourT=request.getParameter("ref11").trim();
	 alertscript=request.getParameter("ref12").trim();
	 alertmail=request.getParameter("ref13").trim();
	 alerttime=request.getParameter("ref14").trim();
	 haappkey=request.getParameter("ref15").trim();
	 haappip=request.getParameter("ref16").trim();
	 runcommand=request.getParameter("ref17").trim();
	 //System.out.println("runcommand is:"+runcommand);
	 filename="";

	// New resource.
	Cluster_HAApp_conf rs=null;
	try {
		rs = new Cluster_HAApp_conf();
		if(rs==null)
			System.out.println("rs is null.");
		else System.out.println("rs is not null.");
	}catch(Exception e){
		System.out.println("Exception:"+e);
	}

	 
	String server = null;
	int port = 0;
	try {
		port = 7001;
		server = InetAddress.getLocalHost().getHostName();
	}catch(Exception exp){
		out.println("<html><head><title>Error Server</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	if (rs==null)
	{
		out.println("<html><head><title>Error Name</title></head>");
		out.println("<body BACKGROUND=\"http://"+server+"/back.gif\" NOSAVE><p><br><center><h2>No matched Resource</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	out.println("<html>");
	out.println("<head>");
	out.println("<title>HA application configure </title>");
	out.println("<html><head><title>HA node Config</title></head>");
	out.println("<body BACKGROUND=\"http://"+server+"/back1.jpg\" NOSAVE><center>");
	
	// set reference on this new resource
	rs.setHAAppname(appname);
	rs.setNodepair(nodepair);
	rs.setPrinode(prinode);
	rs.setSecnode(secnode);
	rs.setHostgroup(hostgroup);
	rs.setMonTime(montime);
	rs.setMonFilename(monfile);
	rs.setWorkDayF(workdayF);
	rs.setWorkDayT(workdayT);
	rs.setWorkHourF(workhourF);
	rs.setWorkHourT(workhourT);
	rs.setAlertScript(alertscript);
	rs.setAlertMail(alertmail);
	rs.setAlertTime(alerttime);
	rs.setAppKey(haappkey);
	rs.setHAIP(haappip);
	rs.setRunCommand(runcommand);
	
	if(debugflag) System.out.println("begin to make HA application configure files.");
	// read files from HA nodes
	//not finished.
	
	// write to tmp file
	rs.writeToFile("mon.cf","p");
	if(debugflag) System.out.println("after write mon.cf on pri node");
	rs.writeToFile("mon.cf","s");
	if(debugflag) System.out.println("after write mon.cf on sec node");
	rs.writeToFile("app.monitor","p");
	if(debugflag) System.out.println("after write app monitor on pri node");
	rs.writeToFile("app.monitor","s");
	if(debugflag) System.out.println("after write app monitor on sec node");
	rs.writeToFile("alert.script","p");
	if(debugflag) System.out.println("after write alert script on pri node");
	rs.writeToFile("alert.script","s");
	if(debugflag) System.out.println("after write alert script on sec node");
	rs.writeToFile("haresources","p");
	if(debugflag) System.out.println("after write haresources on primary node");
	rs.writeToFile("haresources","s");
	if(debugflag) System.out.println("after write haresources on sec node");

	// config this application into HAapplist
	AddHAapp(appname,nodepair,prinode,secnode);
	
	out.println("<br><h2>Are you sure you want to transfer configuration files from server to HA nodes ...</h2></center>");

	// transfer from server to node
	out.println("<script language=\"javascript\">");
	out.println("function cpfile()");
	out.println("{");
	out.println("location.href = \"http://\"+location.hostname+\"/haappconf.html\";");
	out.println("}");
	out.println("</script>");

	out.println("<p><center>");
	
	//System.out.println("refnum:"+refnum);
	out.println("<input TYPE=\"button\" VALUE=\"  return \" onclick=\"cpfile()\" name=\"a\">");
	out.println("</p></center>");
	out.println("</body>");
	
	out.println("</html>");
	out.close();
	return;
  }
	public void AddHAapp(String appname,String Nodepair,String prinode,String secnode)
	{
		String tfile="/etc/HAapps.conf";
		String dfile="/etc/HAscript/tmp/HAapps.conf";
		boolean haflag=true;
		
		try{
			RandomAccessFile in=new RandomAccessFile(tfile,"r");
			FileWriter out=new FileWriter(dfile);				
			
			String line="";
			while((line=in.readLine())!=null)
			{
				StringTokenizer st1=new StringTokenizer(line," ");
				String word=null;
				if(st1.hasMoreTokens())
				{
					word=st1.nextToken();
					if(!word.equals(appname))
					{
						for(int i=0;i<line.length();i++)
							out.write(line.charAt(i));
						out.write('\n');
					}
					else
					{
						word=st1.nextToken();
						if(!word.equals(Nodepair))
						{
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							out.write('\n');
						}
					}
				}
			}						
			String a=appname+" "+Nodepair+" "+prinode+" "+secnode+"\n";
			out.write(a);
			in.close();
			out.close();
	 	}catch(IOException e){
			System.out.println("Exception:"+e);
		}
		cpfile("/etc/HAscript/tmp/HAapps.conf","/etc/HAapps.conf");
	}
	public void cpfile(String fromfile,String tofile)
	{
		try{
				File inputFile = new File(fromfile);
				File outputFile = new File(tofile);

				FileReader in = new FileReader(inputFile);
				FileWriter out = new FileWriter(outputFile);
				int c;

				while ((c = in.read()) != -1)
					out.write(c);

				in.close();
				out.close();
    		}catch(IOException e){
			System.out.println("Exception:"+e);
			}
	}


}
