// Author: WangLin   
// Last modified: 01/8/23

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.manipulate.*;
import CLUSTERPROBE.security.*;
import CLUSTERPROBE.message.*;

//modified from CICS_Manipulate
public class CICS_HAnodeMani extends HttpServlet
{
	String preset="/etc/presets";
	Hashtable ht;
	long timeout = 6000;
	String lname = "";
	String passwd = "";
	String rserver = "";
	String type = "";
	String file="";
	int flag=0;
	String next="";
	String app="";
	String appalert="";

	public static Hashtable groupToHost = new Hashtable();
	public static Vector sType = new Vector();

public CICS_HAnodeMani()
{
	super();
	sType.addElement("Anthony|DP");
	sType.addElement("Benny|DP");
	initGroup();
	EventTransceiver.current = null;
}
// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();
	if(ht==null) ht = ManipulateFile.getPreset(preset);
	
	String server = "";
	int port = 7003;
	Hashtable opts = new Hashtable();
	Vector hosts = new Vector();
	ManipulateEvent evt = null;
	int priority = ManipulateEvent.MAX_PRIORITY;
	
	try {
		server = InetAddress.getLocalHost().getHostName();
	}catch(Exception e){};


	evt = new ManipulateEvent();
	System.out.println("after new ManipulateEvent");
	evt.setName("Manual");
						 
	lname = request.getParameter("lname").trim();
	//System.out.println("user name is:"+lname);
					   
	passwd = request.getParameter("passwd").trim();
	//System.out.println("passwd is:"+passwd);
	rserver = request.getParameter("server").trim();
	type = request.getParameter("type").trim();
	try{
		flag = Integer.parseInt(request.getParameter("flag").trim());
	}catch(Exception e){}
	if(!type.equals("nodeinstall"))
		if (flag==1)
			next=request.getParameter("next").trim();
	//System.out.println("lname="+lname+";passwd="+passwd+";rserver="+rserver);
	String command = "";
	
	out.println("</head>");
	out.println("<body background=\"http://"+server+"/back1.jpg\" nosave>");
	out.println("<center>");

	if (type.equals("start"))
	{
		String hanode = request.getParameter("hanode").trim();
		command="/etc/HAscript/startha";
		//DoCommand(rserver,lname,passwd,command,out);
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("stop"))
	{
		String hanode = request.getParameter("hanode").trim();
		command="/etc/HAscript/stopha";
		//DoCommand(rserver,lname,passwd,command,out);
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("restart"))
	{
		String hanode = request.getParameter("hanode").trim();
		command="/etc/HAscript/restartha";
		//DoCommand(rserver,lname,passwd,command,out);
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("set"))
	{
		String hanode = request.getParameter("hanode").trim();
		command="/etc/HAscript/setHB";
		//DoCommand(rserver,lname,passwd,command,out);
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("ranMani"))
	{
		String hanode = request.getParameter("hanode").trim();
		String dir="/etc/ha.d/";
		file=request.getParameter("file").trim();
		if(file.equals("mon.cf"))
			dir="/etc/mon/";
		command="rcp /etc/HAscript/tmp/"+file+" "+hanode+":"+dir+file;
		//DoCommand(rserver,lname,passwd,command,out);
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("haapps1"))
		// for HA application configure step 1 : copy two files from pri node
	{
		// copy file haresources 
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		String hanode = request.getParameter("haprinode").trim();
  	    String command2="rcp "+hanode+":/etc/ha.d/haresources /etc/HAscript/tmp/haresources.tmp1";		
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command2));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		// copy file mon.cf
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		String command1="rcp "+hanode+":/etc/mon/mon.cf /etc/HAscript/tmp/mon.cf.tmp1";		//DoCommand(rserver,lname,passwd,command1,out);
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command1));
		DoCommand(hosts,evt,lname,passwd,opts,out);
	}
	else if(type.equals("haapps2"))
		// for HA application configure step 2: copy two files from sec node
	{
		String hanode = request.getParameter("hasecnode").trim();
		String command2="rcp "+hanode+":/etc/ha.d/haresources /etc/HAscript/tmp/haresources.tmp2";		
		String command1="rcp "+hanode+":/etc/mon/mon.cf /etc/HAscript/tmp/mon.cf.tmp2";
		// copy file resources
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command2));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		// copy file mon.cf
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command1));
		DoCommand(hosts,evt,lname,passwd,opts,out);

	}
	else if(type.equals("haapps3"))
		// for HA application configure step 3: copy files from server to primary node
	{
		String hanode = request.getParameter("hanode").trim();

		// copy haresource file
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/pri.haresources "+hanode+":/etc/ha.d/haresources ";		
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		//System.out.println("cp haresources to primary node :/etc/ha.d/");
		DoCommand(hosts,evt,lname,passwd,opts,out);

		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/pri.mon.cf "+hanode+":/etc/mon/mon.cf ";
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		//System.out.println("cp mon.cf to primary node :/etc/mon/");
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		app=request.getParameter("app").trim();
		//appalert=request.getParameter("appalert").trim();
		// Run script when Application is started.
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/pri."+app+" "+hanode+":/etc/rc.d/init.d/"+app;
		//System.out.println("cp Application Run script :"+ app+": to primary node :/etc/rc.d/init.d/");
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);

		// monitor application script
		command="rcp /etc/HAscript/tmp/pri."+app+".monitor "+hanode+":/usr/lib/mon/mon.d/"+app+".monitor";
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		//System.out.println("cp monitor application script:"+app+".monitor "+": to primary node :/etc/mon/");
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		// Application alert script
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/pri."+app+".run "+hanode+":/usr/lib/mon/alert.d/"+app+".run";
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /usr/lib/mon/alert.d/"+app+".run";
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /usr/lib/mon/mon.d/"+app+".monitor";
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);

		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /etc/rc.d/init.d/"+app;
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);

		//System.out.println("cp Application alert script:"+appalert+": to primary node :/usr/lib/mon/alert.d/");
	}
	else if(type.equals("haapps4"))
		// for HA application configure step 4: copy files from server to secondary node
	{
		String hanode = request.getParameter("hanode").trim();

		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/sec.haresources "+hanode+":/etc/ha.d/haresources ";		
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		//System.out.println("cp haresources to sec node :/etc/ha.d/");
		command="rcp /etc/HAscript/tmp/sec.mon.cf "+hanode+":/etc/mon/mon.cf ";
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		//System.out.println("cp mon.cf to sec node :/etc/mon/");
		app=request.getParameter("app").trim();
		//appalert=request.getParameter("appalert").trim();
		// Run script when Application is started.
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/sec."+app+" "+hanode+":/etc/rc.d/init.d/"+app;
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		//System.out.println("cp Application Run script :"+ app+": to sec node :/etc/rc.d/init.d/");
		// monitor application script
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/sec."+app+".monitor "+hanode+":/usr/lib/mon/mon.d/"+app+".monitor";
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		//System.out.println("cp monitor application script:"+app+".monitor "+": to sec node :/etc/mon/");
		// Application alert script
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="rcp /etc/HAscript/tmp/sec."+app+".run "+hanode+":/usr/lib/mon/alert.d/"+app+".run";
		hosts.addElement(rserver.trim());
		opts.put(rserver.trim(),new ScriptManipulation(command));
		//System.out.println("cp Application alert script:"+appalert+": to sec node :/usr/lib/mon/alert.d/");
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /usr/lib/mon/alert.d/"+app+".run";
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);
		
		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /usr/lib/mon/mon.d/"+app+".monitor";
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);

		hosts.removeAllElements();
		evt = new ManipulateEvent();
		evt.setName("Manual");
		command="chmod a+x /etc/rc.d/init.d/"+app;
		hosts.addElement(hanode.trim());
		opts.put(hanode.trim(),new ScriptManipulation(command));
		DoCommand(hosts,evt,lname,passwd,opts,out);

	}
	else if(type.equals("haapps5"))
	{
		String prin=request.getParameter("prin").trim();
		String app=request.getParameter("app").trim();
		String secn=request.getParameter("secn").trim();

		String command1="/usr/lib/mon/alert.d/"+app+".run";

		hosts.addElement(prin.trim());
		opts.put(prin.trim(),new ScriptManipulation(command1));
		hosts.addElement(secn.trim());
		opts.put(secn.trim(),new ScriptManipulation(command1));
		
		if(hosts.size()>0) evt.addOrder(priority++,hosts);
		evt.setOperations(opts);
		
		DoCommand(hosts,evt,lname,passwd,opts,out);
		//DoCommand(secn,slname,spwd,command1,out);
	}
	else if(type.equals("nodeinstall"))
	{
		String oper=request.getParameter("oper").trim();
		String[] emon={"perl-Convert-BER-1.26-6.i386.rpm","perl-Period-1.20-6.i386.rpm","perl-Time-HiRes-01.20-6.i386.rpm","perl-TimeDate-1.08-2.i386.rpm","mon-0.38.15-1.i386.rpm"};
		String[] eheart={"heartbeat-0.4.9-1.i386.rpm"};
		int[] entryIndex = null;
		// get the seleted packet index.
		String entries="";;
		try {
			entries = request.getParameter("entries");
			if (entries!=null) {
				StringTokenizer st = new StringTokenizer(entries,"|");
				entryIndex = new int[st.countTokens()];
				for (int i=0;i<entryIndex.length;i++)
					entryIndex[i] = Integer.parseInt(st.nextToken().trim());
			}
		}catch(Exception e1){};

		String[] e=null; 
		int rindex=Integer.parseInt(request.getParameter("rindex"));
		if(rindex==0) 
			e=emon;
		else 
			e=eheart;
						  
		String rhosts = null;
		String[] ehosts=null;
		try {
			rhosts = request.getParameter("hosts");
			if (rhosts!=null) {
				StringTokenizer st = new StringTokenizer(rhosts,"|");
				ehosts = new String[st.countTokens()];
				for (int i=0;i<ehosts.length;i++)
					ehosts[i] = st.nextToken().trim();
			}

		}catch(Exception e3){};

		if(oper.equals("copyfile"))
	   {
		for(int i=0;i<ehosts.length;i++)
		{
			hosts.addElement(ehosts[i].trim());
			String command0="mkdir /HArpm";
			opts.put(ehosts[i].trim(),new ScriptManipulation(command0));
		}		

		DoCommand(hosts,evt,lname,passwd,opts,out);

		//String command1="rcp "+server+":/etc/HAscript/tmp/rpm/"+file+" "+node+":/HArpm/";
		//String command0="mkdir /HArpm";
		for(int j=0;j<ehosts.length;j++)
		for(int i=0;i<entryIndex.length;i++)
		{
			hosts.removeAllElements();
			hosts.addElement(server.trim());
			evt = new ManipulateEvent();
			evt.setName("Manual");

			String command1="rcp /etc/HAscript/tmp/rpm/"+e[entryIndex[i]]+" "+ehosts[j]+":/HArpm/.";
			//System.out.println("in CICS_HAnodeMani:"+command1);
			opts.put(server.trim(),new ScriptManipulation(command1));
			DoCommand(hosts,evt,lname,passwd,opts,out);

		}
		}
		else if(oper.equals("rpm"))
		{
			for(int j=0;j<ehosts.length;j++)
			for(int i=0;i<entryIndex.length;i++)
			{
				hosts.removeAllElements();
				evt = new ManipulateEvent();
				evt.setName("Manual");

				hosts.addElement(ehosts[j].trim());
				String command1="rpm -i /HArpm/"+e[entryIndex[i]];
				System.out.println("in CICS_HAnodeMani:"+command1);
				opts.put(ehosts[j].trim(),new ScriptManipulation(command1));
				DoCommand(hosts,evt,lname,passwd,opts,out);
			}
		}else
			System.out.println("Wrong oper");
		if(flag==1)
		{
		//next = request.getParameter("next").trim();
		out.println("<script language=\"javascript\">");
		out.println("function next2()");
		out.println("{");
		out.println("window.close();");
		out.println("}");
		out.println("</script>");
		out.println("<script language=javascript> next2();</script>");
		return;
		}
	}
	else 
	{
		String filename="";
		//String server = InetAddress.getLocalHost().getHostName();
		out.println("<html><head><title>Error type</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>Wrong reference Number</h2>");
		out.println("</center></body></html>");
		out.close();
		return;	
	}
	/*if(!type.equals("nodeinstall"))
	{
		DoCommand(hosts,evt,lname,passwd,opts,out);
		if(hosts.size()>0) evt.addOrder(priority++,hosts);
		evt.setOperations(opts);

		Password pw = new Password("/tmp",lname,passwd);
		evt.setPasswd(pw);

		ManEventHandler handler = new ManEventHandler(evt,out);

		try 
		{
			if (EventTransceiver.current==null)
				new EventTransceiver(server,port);
			EventTransceiver.current.addHandler(handler,new ManipulateResultEvent());
			EventTransceiver.current.addHandler(handler,new ManipulateErrorEvent());
			//System.out.println("in CICS_HAnodeMani.java, after add two handler");
			EventTransceiver.current.sendEvent(evt);
			//System.out.println("in CICS_HAnodeMani.java, after send Event");
		}catch(Exception eee) {
			System.out.println(eee);
		}

		long timeCount = timeout/1000;

		while (true)
		{
			if (handler.isEnd())
			{
				break;
			}
			else
				try{Thread.sleep(1000);}catch(Exception excep){};
			if (timeCount--==0)
				break;
		}

	}*/
	if(flag==1)
	{
		//next = request.getParameter("next").trim();
		out.println("<script language=\"javascript\">");
		out.println("function next1()");
		out.println("{");
		out.println("location.href=\"http://\"+location.hostname+\""+next+"\";");
		out.println("}");
		out.println("</script>");
		out.println("<input type=\"button\" value=\"Next\" onclick=\"next1()\">");
	}

	out.println("</center>");
	out.println("</body></html>");
	out.close(); 
}

public void DoCommand(Vector hosts,ManipulateEvent evt,String lname,String passwd,Hashtable opts,PrintWriter out)
{
	int priority = ManipulateEvent.MAX_PRIORITY;
	String server = "";
	int port = 7003;
	
	try {
		server = InetAddress.getLocalHost().getHostName();
	}catch(Exception e){};

	if(hosts.size()>0) evt.addOrder(priority++,hosts);
	evt.setOperations(opts);

	Password pw = new Password("/tmp",lname,passwd);
	evt.setPasswd(pw);

	ManEventHandler handler = new ManEventHandler(evt,out);

	try 
	{
		if (EventTransceiver.current==null)
			new EventTransceiver(server,port);
		EventTransceiver.current.addHandler(handler,new ManipulateResultEvent());
		EventTransceiver.current.addHandler(handler,new ManipulateErrorEvent());
		//System.out.println("in CICS_HAnodeMani.java, after add two handler");
		EventTransceiver.current.sendEvent(evt);
		//System.out.println("in CICS_HAnodeMani.java, after send Event");
	}catch(Exception eee) {
		System.out.println(eee);
	}

	long timeCount = timeout/1000;

	while (true)
	{
		if (handler.isEnd())
		{
			break;
		}
		else
			try{Thread.sleep(1000);}catch(Exception excep){};
		if (timeCount--==0)
			break;
			
	}


}
public static void initGroup()
{
String server = null;
int port = 7001;

try {
	server = InetAddress.getLocalHost().getHostName();
}catch(Exception ee) {
	System.out.println("Retrieve server and port fail!");
	return;
}
/*
//System.out.println(server+" "+port);
GetCurrentValueDemo demo = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_NodeLists",server,port);
try {
	Thread.sleep(200);
}catch(Exception eee){};
int kk = 0;
for (kk=0;kk<10;kk++)
{
	if (demo.over)
		break;
	try {
		Thread.sleep(1000);
	}catch(Exception exp){};
}
if (kk==10) 
{
	System.out.println("Time out");
	return;
}

if (!demo.success)
{
	System.out.println("fail");
	return;
}

Vector dv = null;
try{
dv = (Vector)demo.value.elementAt(0);
}catch(Exception eee){
	System.out.println(eee);
	return;
}
if (dv==null)
{
	System.out.println("data is null");
	return;
}

Enumeration hostEn = dv.elements();
groupToHost = new Hashtable();
while (hostEn.hasMoreElements())
{
	ResourceTableData data = (ResourceTableData) hostEn.nextElement();
	Vector vt = data.getRecord();
	if (((Integer)vt.elementAt(4)).intValue()!=0)
		continue;
	String groupname = (String) vt.elementAt(2);
	Vector gv = new Vector();
	if (groupToHost.containsKey(groupname))
		gv = (Vector) groupToHost.get(groupname);
	else
		groupToHost.put(groupname,gv);
	gv.addElement(vt.elementAt(1));
}*/
}

}