//Author: WangLin
//Last modified: Aug. 06 ,2001

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.Resource;

public class CICS_QueryServlet extends HttpServlet
{
// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

	String rname = request.getParameter("rname").trim();
	//get the parameter which user gives within the request

	Resource rs = null;
	try {
		rs = (Resource) Class.forName(rname).newInstance();
		// new a class which is in "rname" type
	}catch(Exception e){
		System.out.println("exception catched while newInstance of:"+rname);
	};

	String server = null;
	int port = 0;
	try {
		port = 7001;
		server = InetAddress.getLocalHost().getHostName();
	}catch(Exception exp){
		System.out.println("exception catched while server = InetAddress.getLocalHost().getHostName()");
		out.println("<html><head><title>Error Server</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	if (rs==null)
	{
		out.println("<html><head><title>Error Name</title></head>");
		out.println("<body BACKGROUND=\"http://"+server+"/back.gif\" NOSAVE><p><br><center><h2>No matched Resource</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}
		
	GetCurrentValueDemo demo = new GetCurrentValueDemo(rname,server,port);
	//System.out.println("end of GetCurrentValueDemo from "+rname);
	try {
	Thread.sleep(500);
	}catch(Exception ee){};

	int i=0;
	for(i=0;i<10;i++) {
		if (demo.over)
			break;
		try {
		Thread.sleep(2000);	
		}catch(Exception e0){};
	}
	if (i==10) {
		out.println("<html><head><title>Timeout</title></head>");
		out.println("<body BACKGROUND=\"http://"+server+"/back1.jpg\" NOSAVE><center><br><h2>Query "+rs.getDesc()+" Timeout</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}
	
	int count = rs.getUpdateTime()/1000;
	if (count>0) 
		out.println("<html><META http-equiv='refresh' content='"+(count+5)+", URL=/'>");
	else
		out.println("<html>");

	out.println("<head><title> Query CICS </title>");
	String outText = new String(demo.result);

	out.println("<body background=\"http://"+server+"/back1.jpg\" NOSAVE><center>");
	if (demo.hostTable.size()>0)
	{
		out.println("<table cols=5 width=100%>");
		out.println("<tr>");
	}
	for (int kk=0;kk<demo.hostTable.size();kk++)
	{
		String hn = (String) demo.hostTable.elementAt(kk);
		out.println("<td align=center><a href=\"#"+hn+"\">"+hn+"</a></td>");
		if ((kk%5)==0&&kk!=0)
			out.println("</tr><tr>");
	}
	if ((demo.hostTable.size()%5)!=0)
		out.println("</tr>");
	if (demo.hostTable.size()>0)
		out.println("</table>");
	out.println(outText+"<br><form><input type=\"button\" value=\" Refresh \" onclick=\"location.href=self.location.href\"></form><center>");

	if(rname.equals("CLUSTERPROBE.resources.Cluster_HAappLists"))
    {
		//out.println(outText+"<br><form><input type=\"button\" value=\" Refresh \" onclick=\"location.href=self.location.href\"></form><center>");
		out.write("<script language=\"javascript\">");
		out.write("var statusWin = window.open(\"http://\"+location.hostname+\":8100/servlet/cics_haappstatus\",\"statusWin\");");
		out.write("</script>");
	}
	out.println("</body></html>");
	out.close();
}

	String getHttpText(String result)
	{
		if (result==null||result.length()==0) return result;
		StringBuffer strb = new StringBuffer();

		int count = 0;
		while (true)
		{
			count = result.indexOf(" ");
			if (count!=-1)
			{
				String str1 = "";
				String str2 = "";
				if (count>0) str1 = result.substring(0,count);
				if (count!=(result.length()-1))
					str2 = result.substring(count+1,result.length());
				result = new String(str1+"&nbsp;"+str2);
			}		
			else
				break;
		}
		return result;
	}

}
